<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountPagedResult StructType
 * @subpackage Structs
 */
class AccountPagedResult extends AbstractStructBase
{
    /**
     * The paging
     * @var \StructType\ResultInfo
     */
    public $paging;
    /**
     * The results
     * @var \ArrayType\AccountArray
     */
    public $results;
    /**
     * Constructor method for AccountPagedResult
     * @uses AccountPagedResult::setPaging()
     * @uses AccountPagedResult::setResults()
     * @param \StructType\ResultInfo $paging
     * @param \ArrayType\AccountArray $results
     */
    public function __construct(\StructType\ResultInfo $paging = null, \ArrayType\AccountArray $results = null)
    {
        $this
            ->setPaging($paging)
            ->setResults($results);
    }
    /**
     * Get paging value
     * @return \StructType\ResultInfo|null
     */
    public function getPaging()
    {
        return $this->paging;
    }
    /**
     * Set paging value
     * @param \StructType\ResultInfo $paging
     * @return \StructType\AccountPagedResult
     */
    public function setPaging(\StructType\ResultInfo $paging = null)
    {
        $this->paging = $paging;
        return $this;
    }
    /**
     * Get results value
     * @return \ArrayType\AccountArray|null
     */
    public function getResults()
    {
        return $this->results;
    }
    /**
     * Set results value
     * @param \ArrayType\AccountArray $results
     * @return \StructType\AccountPagedResult
     */
    public function setResults(\ArrayType\AccountArray $results = null)
    {
        $this->results = $results;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccountPagedResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
