<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountV2 StructType
 * @subpackage Structs
 */
class AccountV2 extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The address
     * @var string
     */
    public $address;
    /**
     * The environment
     * @var string
     */
    public $environment;
    /**
     * The reseller
     * @var bool
     */
    public $reseller;
    /**
     * The contactname
     * @var string
     */
    public $contactname;
    /**
     * The contactemail
     * @var string
     */
    public $contactemail;
    /**
     * The telephone
     * @var string
     */
    public $telephone;
    /**
     * The fax
     * @var string
     */
    public $fax;
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * The creationtime
     * @var string
     */
    public $creationtime;
    /**
     * The lastmodified
     * @var string
     */
    public $lastmodified;
    /**
     * The clientcode
     * @var string
     */
    public $clientcode;
    /**
     * The comments
     * @var string
     */
    public $comments;
    /**
     * The usernameprefix
     * @var string
     */
    public $usernameprefix;
    /**
     * The balance
     * @var float
     */
    public $balance;
    /**
     * The balancethreshold
     * @var float
     */
    public $balancethreshold;
    /**
     * Constructor method for AccountV2
     * @uses AccountV2::setId()
     * @uses AccountV2::setName()
     * @uses AccountV2::setAddress()
     * @uses AccountV2::setEnvironment()
     * @uses AccountV2::setReseller()
     * @uses AccountV2::setContactname()
     * @uses AccountV2::setContactemail()
     * @uses AccountV2::setTelephone()
     * @uses AccountV2::setFax()
     * @uses AccountV2::setDescription()
     * @uses AccountV2::setCreationtime()
     * @uses AccountV2::setLastmodified()
     * @uses AccountV2::setClientcode()
     * @uses AccountV2::setComments()
     * @uses AccountV2::setUsernameprefix()
     * @uses AccountV2::setBalance()
     * @uses AccountV2::setBalancethreshold()
     * @param int $id
     * @param string $name
     * @param string $address
     * @param string $environment
     * @param bool $reseller
     * @param string $contactname
     * @param string $contactemail
     * @param string $telephone
     * @param string $fax
     * @param string $description
     * @param string $creationtime
     * @param string $lastmodified
     * @param string $clientcode
     * @param string $comments
     * @param string $usernameprefix
     * @param float $balance
     * @param float $balancethreshold
     */
    public function __construct($id = null, $name = null, $address = null, $environment = null, $reseller = null, $contactname = null, $contactemail = null, $telephone = null, $fax = null, $description = null, $creationtime = null, $lastmodified = null, $clientcode = null, $comments = null, $usernameprefix = null, $balance = null, $balancethreshold = null)
    {
        $this
            ->setId($id)
            ->setName($name)
            ->setAddress($address)
            ->setEnvironment($environment)
            ->setReseller($reseller)
            ->setContactname($contactname)
            ->setContactemail($contactemail)
            ->setTelephone($telephone)
            ->setFax($fax)
            ->setDescription($description)
            ->setCreationtime($creationtime)
            ->setLastmodified($lastmodified)
            ->setClientcode($clientcode)
            ->setComments($comments)
            ->setUsernameprefix($usernameprefix)
            ->setBalance($balance)
            ->setBalancethreshold($balancethreshold);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\AccountV2
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\AccountV2
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param string $address
     * @return \StructType\AccountV2
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address, true), gettype($address)), __LINE__);
        }
        $this->address = $address;
        return $this;
    }
    /**
     * Get environment value
     * @return string|null
     */
    public function getEnvironment()
    {
        return $this->environment;
    }
    /**
     * Set environment value
     * @param string $environment
     * @return \StructType\AccountV2
     */
    public function setEnvironment($environment = null)
    {
        // validation for constraint: string
        if (!is_null($environment) && !is_string($environment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($environment, true), gettype($environment)), __LINE__);
        }
        $this->environment = $environment;
        return $this;
    }
    /**
     * Get reseller value
     * @return bool|null
     */
    public function getReseller()
    {
        return $this->reseller;
    }
    /**
     * Set reseller value
     * @param bool $reseller
     * @return \StructType\AccountV2
     */
    public function setReseller($reseller = null)
    {
        // validation for constraint: boolean
        if (!is_null($reseller) && !is_bool($reseller)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($reseller, true), gettype($reseller)), __LINE__);
        }
        $this->reseller = $reseller;
        return $this;
    }
    /**
     * Get contactname value
     * @return string|null
     */
    public function getContactname()
    {
        return $this->contactname;
    }
    /**
     * Set contactname value
     * @param string $contactname
     * @return \StructType\AccountV2
     */
    public function setContactname($contactname = null)
    {
        // validation for constraint: string
        if (!is_null($contactname) && !is_string($contactname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactname, true), gettype($contactname)), __LINE__);
        }
        $this->contactname = $contactname;
        return $this;
    }
    /**
     * Get contactemail value
     * @return string|null
     */
    public function getContactemail()
    {
        return $this->contactemail;
    }
    /**
     * Set contactemail value
     * @param string $contactemail
     * @return \StructType\AccountV2
     */
    public function setContactemail($contactemail = null)
    {
        // validation for constraint: string
        if (!is_null($contactemail) && !is_string($contactemail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactemail, true), gettype($contactemail)), __LINE__);
        }
        $this->contactemail = $contactemail;
        return $this;
    }
    /**
     * Get telephone value
     * @return string|null
     */
    public function getTelephone()
    {
        return $this->telephone;
    }
    /**
     * Set telephone value
     * @param string $telephone
     * @return \StructType\AccountV2
     */
    public function setTelephone($telephone = null)
    {
        // validation for constraint: string
        if (!is_null($telephone) && !is_string($telephone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($telephone, true), gettype($telephone)), __LINE__);
        }
        $this->telephone = $telephone;
        return $this;
    }
    /**
     * Get fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->fax;
    }
    /**
     * Set fax value
     * @param string $fax
     * @return \StructType\AccountV2
     */
    public function setFax($fax = null)
    {
        // validation for constraint: string
        if (!is_null($fax) && !is_string($fax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->fax = $fax;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\AccountV2
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get creationtime value
     * @return string|null
     */
    public function getCreationtime()
    {
        return $this->creationtime;
    }
    /**
     * Set creationtime value
     * @param string $creationtime
     * @return \StructType\AccountV2
     */
    public function setCreationtime($creationtime = null)
    {
        // validation for constraint: string
        if (!is_null($creationtime) && !is_string($creationtime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($creationtime, true), gettype($creationtime)), __LINE__);
        }
        $this->creationtime = $creationtime;
        return $this;
    }
    /**
     * Get lastmodified value
     * @return string|null
     */
    public function getLastmodified()
    {
        return $this->lastmodified;
    }
    /**
     * Set lastmodified value
     * @param string $lastmodified
     * @return \StructType\AccountV2
     */
    public function setLastmodified($lastmodified = null)
    {
        // validation for constraint: string
        if (!is_null($lastmodified) && !is_string($lastmodified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastmodified, true), gettype($lastmodified)), __LINE__);
        }
        $this->lastmodified = $lastmodified;
        return $this;
    }
    /**
     * Get clientcode value
     * @return string|null
     */
    public function getClientcode()
    {
        return $this->clientcode;
    }
    /**
     * Set clientcode value
     * @param string $clientcode
     * @return \StructType\AccountV2
     */
    public function setClientcode($clientcode = null)
    {
        // validation for constraint: string
        if (!is_null($clientcode) && !is_string($clientcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientcode, true), gettype($clientcode)), __LINE__);
        }
        $this->clientcode = $clientcode;
        return $this;
    }
    /**
     * Get comments value
     * @return string|null
     */
    public function getComments()
    {
        return $this->comments;
    }
    /**
     * Set comments value
     * @param string $comments
     * @return \StructType\AccountV2
     */
    public function setComments($comments = null)
    {
        // validation for constraint: string
        if (!is_null($comments) && !is_string($comments)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comments, true), gettype($comments)), __LINE__);
        }
        $this->comments = $comments;
        return $this;
    }
    /**
     * Get usernameprefix value
     * @return string|null
     */
    public function getUsernameprefix()
    {
        return $this->usernameprefix;
    }
    /**
     * Set usernameprefix value
     * @param string $usernameprefix
     * @return \StructType\AccountV2
     */
    public function setUsernameprefix($usernameprefix = null)
    {
        // validation for constraint: string
        if (!is_null($usernameprefix) && !is_string($usernameprefix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($usernameprefix, true), gettype($usernameprefix)), __LINE__);
        }
        $this->usernameprefix = $usernameprefix;
        return $this;
    }
    /**
     * Get balance value
     * @return float|null
     */
    public function getBalance()
    {
        return $this->balance;
    }
    /**
     * Set balance value
     * @param float $balance
     * @return \StructType\AccountV2
     */
    public function setBalance($balance = null)
    {
        // validation for constraint: float
        if (!is_null($balance) && !(is_float($balance) || is_numeric($balance))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($balance, true), gettype($balance)), __LINE__);
        }
        $this->balance = $balance;
        return $this;
    }
    /**
     * Get balancethreshold value
     * @return float|null
     */
    public function getBalancethreshold()
    {
        return $this->balancethreshold;
    }
    /**
     * Set balancethreshold value
     * @param float $balancethreshold
     * @return \StructType\AccountV2
     */
    public function setBalancethreshold($balancethreshold = null)
    {
        // validation for constraint: float
        if (!is_null($balancethreshold) && !(is_float($balancethreshold) || is_numeric($balancethreshold))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($balancethreshold, true), gettype($balancethreshold)), __LINE__);
        }
        $this->balancethreshold = $balancethreshold;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccountV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
