<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessAnnualFinancialStatement StructType
 * @subpackage Structs
 */
class BelgianBusinessAnnualFinancialStatement extends AbstractStructBase
{
    /**
     * The id
     * @var string
     */
    public $id;
    /**
     * The year
     * @var int
     */
    public $year;
    /**
     * The number_of_employees
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $number_of_employees;
    /**
     * The turnover
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $turnover;
    /**
     * The equity
     * @var float
     */
    public $equity;
    /**
     * The revisors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\BelgianBusinessRevisorArray
     */
    public $revisors;
    /**
     * The account_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BelgianBusinessDate
     */
    public $account_date;
    /**
     * The current_assets
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $current_assets;
    /**
     * The gross_operating_margin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $gross_operating_margin;
    /**
     * The tangible_fixed_assets
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $tangible_fixed_assets;
    /**
     * The gain_loss_period
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $gain_loss_period;
    /**
     * The current_ratio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $current_ratio;
    /**
     * The net_cash
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $net_cash;
    /**
     * The self_financing_degree
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $self_financing_degree;
    /**
     * The return_on_equity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $return_on_equity;
    /**
     * The added_value
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $added_value;
    /**
     * The balance_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $balance_type;
    /**
     * The ratios
     * @var \StructType\BelgianBusinessRatios
     */
    public $ratios;
    /**
     * The social_balance
     * @var \StructType\BelgianBusinessSocialBalance
     */
    public $social_balance;
    /**
     * The financial_values
     * @var \StructType\BelgianBusinessFinancialValues
     */
    public $financial_values;
    /**
     * Constructor method for BelgianBusinessAnnualFinancialStatement
     * @uses BelgianBusinessAnnualFinancialStatement::setId()
     * @uses BelgianBusinessAnnualFinancialStatement::setYear()
     * @uses BelgianBusinessAnnualFinancialStatement::setNumber_of_employees()
     * @uses BelgianBusinessAnnualFinancialStatement::setTurnover()
     * @uses BelgianBusinessAnnualFinancialStatement::setEquity()
     * @uses BelgianBusinessAnnualFinancialStatement::setRevisors()
     * @uses BelgianBusinessAnnualFinancialStatement::setAccount_date()
     * @uses BelgianBusinessAnnualFinancialStatement::setCurrent_assets()
     * @uses BelgianBusinessAnnualFinancialStatement::setGross_operating_margin()
     * @uses BelgianBusinessAnnualFinancialStatement::setTangible_fixed_assets()
     * @uses BelgianBusinessAnnualFinancialStatement::setGain_loss_period()
     * @uses BelgianBusinessAnnualFinancialStatement::setCurrent_ratio()
     * @uses BelgianBusinessAnnualFinancialStatement::setNet_cash()
     * @uses BelgianBusinessAnnualFinancialStatement::setSelf_financing_degree()
     * @uses BelgianBusinessAnnualFinancialStatement::setReturn_on_equity()
     * @uses BelgianBusinessAnnualFinancialStatement::setAdded_value()
     * @uses BelgianBusinessAnnualFinancialStatement::setBalance_type()
     * @uses BelgianBusinessAnnualFinancialStatement::setRatios()
     * @uses BelgianBusinessAnnualFinancialStatement::setSocial_balance()
     * @uses BelgianBusinessAnnualFinancialStatement::setFinancial_values()
     * @param string $id
     * @param int $year
     * @param int $number_of_employees
     * @param float $turnover
     * @param float $equity
     * @param \ArrayType\BelgianBusinessRevisorArray $revisors
     * @param \StructType\BelgianBusinessDate $account_date
     * @param float $current_assets
     * @param float $gross_operating_margin
     * @param float $tangible_fixed_assets
     * @param float $gain_loss_period
     * @param float $current_ratio
     * @param float $net_cash
     * @param float $self_financing_degree
     * @param float $return_on_equity
     * @param float $added_value
     * @param float $balance_type
     * @param \StructType\BelgianBusinessRatios $ratios
     * @param \StructType\BelgianBusinessSocialBalance $social_balance
     * @param \StructType\BelgianBusinessFinancialValues $financial_values
     */
    public function __construct($id = null, $year = null, $number_of_employees = null, $turnover = null, $equity = null, \ArrayType\BelgianBusinessRevisorArray $revisors = null, \StructType\BelgianBusinessDate $account_date = null, $current_assets = null, $gross_operating_margin = null, $tangible_fixed_assets = null, $gain_loss_period = null, $current_ratio = null, $net_cash = null, $self_financing_degree = null, $return_on_equity = null, $added_value = null, $balance_type = null, \StructType\BelgianBusinessRatios $ratios = null, \StructType\BelgianBusinessSocialBalance $social_balance = null, \StructType\BelgianBusinessFinancialValues $financial_values = null)
    {
        $this
            ->setId($id)
            ->setYear($year)
            ->setNumber_of_employees($number_of_employees)
            ->setTurnover($turnover)
            ->setEquity($equity)
            ->setRevisors($revisors)
            ->setAccount_date($account_date)
            ->setCurrent_assets($current_assets)
            ->setGross_operating_margin($gross_operating_margin)
            ->setTangible_fixed_assets($tangible_fixed_assets)
            ->setGain_loss_period($gain_loss_period)
            ->setCurrent_ratio($current_ratio)
            ->setNet_cash($net_cash)
            ->setSelf_financing_degree($self_financing_degree)
            ->setReturn_on_equity($return_on_equity)
            ->setAdded_value($added_value)
            ->setBalance_type($balance_type)
            ->setRatios($ratios)
            ->setSocial_balance($social_balance)
            ->setFinancial_values($financial_values);
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get year value
     * @return int|null
     */
    public function getYear()
    {
        return $this->year;
    }
    /**
     * Set year value
     * @param int $year
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setYear($year = null)
    {
        // validation for constraint: int
        if (!is_null($year) && !(is_int($year) || ctype_digit($year))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($year, true), gettype($year)), __LINE__);
        }
        $this->year = $year;
        return $this;
    }
    /**
     * Get number_of_employees value
     * @return int|null
     */
    public function getNumber_of_employees()
    {
        return $this->number_of_employees;
    }
    /**
     * Set number_of_employees value
     * @param int $number_of_employees
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setNumber_of_employees($number_of_employees = null)
    {
        // validation for constraint: int
        if (!is_null($number_of_employees) && !(is_int($number_of_employees) || ctype_digit($number_of_employees))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number_of_employees, true), gettype($number_of_employees)), __LINE__);
        }
        $this->number_of_employees = $number_of_employees;
        return $this;
    }
    /**
     * Get turnover value
     * @return float|null
     */
    public function getTurnover()
    {
        return $this->turnover;
    }
    /**
     * Set turnover value
     * @param float $turnover
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setTurnover($turnover = null)
    {
        // validation for constraint: float
        if (!is_null($turnover) && !(is_float($turnover) || is_numeric($turnover))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($turnover, true), gettype($turnover)), __LINE__);
        }
        $this->turnover = $turnover;
        return $this;
    }
    /**
     * Get equity value
     * @return float|null
     */
    public function getEquity()
    {
        return $this->equity;
    }
    /**
     * Set equity value
     * @param float $equity
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setEquity($equity = null)
    {
        // validation for constraint: float
        if (!is_null($equity) && !(is_float($equity) || is_numeric($equity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($equity, true), gettype($equity)), __LINE__);
        }
        $this->equity = $equity;
        return $this;
    }
    /**
     * Get revisors value
     * @return \ArrayType\BelgianBusinessRevisorArray|null
     */
    public function getRevisors()
    {
        return $this->revisors;
    }
    /**
     * Set revisors value
     * @param \ArrayType\BelgianBusinessRevisorArray $revisors
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setRevisors(\ArrayType\BelgianBusinessRevisorArray $revisors = null)
    {
        $this->revisors = $revisors;
        return $this;
    }
    /**
     * Get account_date value
     * @return \StructType\BelgianBusinessDate|null
     */
    public function getAccount_date()
    {
        return $this->account_date;
    }
    /**
     * Set account_date value
     * @param \StructType\BelgianBusinessDate $account_date
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setAccount_date(\StructType\BelgianBusinessDate $account_date = null)
    {
        $this->account_date = $account_date;
        return $this;
    }
    /**
     * Get current_assets value
     * @return float|null
     */
    public function getCurrent_assets()
    {
        return $this->current_assets;
    }
    /**
     * Set current_assets value
     * @param float $current_assets
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setCurrent_assets($current_assets = null)
    {
        // validation for constraint: float
        if (!is_null($current_assets) && !(is_float($current_assets) || is_numeric($current_assets))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($current_assets, true), gettype($current_assets)), __LINE__);
        }
        $this->current_assets = $current_assets;
        return $this;
    }
    /**
     * Get gross_operating_margin value
     * @return float|null
     */
    public function getGross_operating_margin()
    {
        return $this->gross_operating_margin;
    }
    /**
     * Set gross_operating_margin value
     * @param float $gross_operating_margin
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setGross_operating_margin($gross_operating_margin = null)
    {
        // validation for constraint: float
        if (!is_null($gross_operating_margin) && !(is_float($gross_operating_margin) || is_numeric($gross_operating_margin))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gross_operating_margin, true), gettype($gross_operating_margin)), __LINE__);
        }
        $this->gross_operating_margin = $gross_operating_margin;
        return $this;
    }
    /**
     * Get tangible_fixed_assets value
     * @return float|null
     */
    public function getTangible_fixed_assets()
    {
        return $this->tangible_fixed_assets;
    }
    /**
     * Set tangible_fixed_assets value
     * @param float $tangible_fixed_assets
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setTangible_fixed_assets($tangible_fixed_assets = null)
    {
        // validation for constraint: float
        if (!is_null($tangible_fixed_assets) && !(is_float($tangible_fixed_assets) || is_numeric($tangible_fixed_assets))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($tangible_fixed_assets, true), gettype($tangible_fixed_assets)), __LINE__);
        }
        $this->tangible_fixed_assets = $tangible_fixed_assets;
        return $this;
    }
    /**
     * Get gain_loss_period value
     * @return float|null
     */
    public function getGain_loss_period()
    {
        return $this->gain_loss_period;
    }
    /**
     * Set gain_loss_period value
     * @param float $gain_loss_period
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setGain_loss_period($gain_loss_period = null)
    {
        // validation for constraint: float
        if (!is_null($gain_loss_period) && !(is_float($gain_loss_period) || is_numeric($gain_loss_period))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gain_loss_period, true), gettype($gain_loss_period)), __LINE__);
        }
        $this->gain_loss_period = $gain_loss_period;
        return $this;
    }
    /**
     * Get current_ratio value
     * @return float|null
     */
    public function getCurrent_ratio()
    {
        return $this->current_ratio;
    }
    /**
     * Set current_ratio value
     * @param float $current_ratio
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setCurrent_ratio($current_ratio = null)
    {
        // validation for constraint: float
        if (!is_null($current_ratio) && !(is_float($current_ratio) || is_numeric($current_ratio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($current_ratio, true), gettype($current_ratio)), __LINE__);
        }
        $this->current_ratio = $current_ratio;
        return $this;
    }
    /**
     * Get net_cash value
     * @return float|null
     */
    public function getNet_cash()
    {
        return $this->net_cash;
    }
    /**
     * Set net_cash value
     * @param float $net_cash
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setNet_cash($net_cash = null)
    {
        // validation for constraint: float
        if (!is_null($net_cash) && !(is_float($net_cash) || is_numeric($net_cash))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($net_cash, true), gettype($net_cash)), __LINE__);
        }
        $this->net_cash = $net_cash;
        return $this;
    }
    /**
     * Get self_financing_degree value
     * @return float|null
     */
    public function getSelf_financing_degree()
    {
        return $this->self_financing_degree;
    }
    /**
     * Set self_financing_degree value
     * @param float $self_financing_degree
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setSelf_financing_degree($self_financing_degree = null)
    {
        // validation for constraint: float
        if (!is_null($self_financing_degree) && !(is_float($self_financing_degree) || is_numeric($self_financing_degree))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($self_financing_degree, true), gettype($self_financing_degree)), __LINE__);
        }
        $this->self_financing_degree = $self_financing_degree;
        return $this;
    }
    /**
     * Get return_on_equity value
     * @return float|null
     */
    public function getReturn_on_equity()
    {
        return $this->return_on_equity;
    }
    /**
     * Set return_on_equity value
     * @param float $return_on_equity
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setReturn_on_equity($return_on_equity = null)
    {
        // validation for constraint: float
        if (!is_null($return_on_equity) && !(is_float($return_on_equity) || is_numeric($return_on_equity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($return_on_equity, true), gettype($return_on_equity)), __LINE__);
        }
        $this->return_on_equity = $return_on_equity;
        return $this;
    }
    /**
     * Get added_value value
     * @return float|null
     */
    public function getAdded_value()
    {
        return $this->added_value;
    }
    /**
     * Set added_value value
     * @param float $added_value
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setAdded_value($added_value = null)
    {
        // validation for constraint: float
        if (!is_null($added_value) && !(is_float($added_value) || is_numeric($added_value))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($added_value, true), gettype($added_value)), __LINE__);
        }
        $this->added_value = $added_value;
        return $this;
    }
    /**
     * Get balance_type value
     * @return float|null
     */
    public function getBalance_type()
    {
        return $this->balance_type;
    }
    /**
     * Set balance_type value
     * @param float $balance_type
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setBalance_type($balance_type = null)
    {
        // validation for constraint: float
        if (!is_null($balance_type) && !(is_float($balance_type) || is_numeric($balance_type))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($balance_type, true), gettype($balance_type)), __LINE__);
        }
        $this->balance_type = $balance_type;
        return $this;
    }
    /**
     * Get ratios value
     * @return \StructType\BelgianBusinessRatios|null
     */
    public function getRatios()
    {
        return $this->ratios;
    }
    /**
     * Set ratios value
     * @param \StructType\BelgianBusinessRatios $ratios
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setRatios(\StructType\BelgianBusinessRatios $ratios = null)
    {
        $this->ratios = $ratios;
        return $this;
    }
    /**
     * Get social_balance value
     * @return \StructType\BelgianBusinessSocialBalance|null
     */
    public function getSocial_balance()
    {
        return $this->social_balance;
    }
    /**
     * Set social_balance value
     * @param \StructType\BelgianBusinessSocialBalance $social_balance
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setSocial_balance(\StructType\BelgianBusinessSocialBalance $social_balance = null)
    {
        $this->social_balance = $social_balance;
        return $this;
    }
    /**
     * Get financial_values value
     * @return \StructType\BelgianBusinessFinancialValues|null
     */
    public function getFinancial_values()
    {
        return $this->financial_values;
    }
    /**
     * Set financial_values value
     * @param \StructType\BelgianBusinessFinancialValues $financial_values
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public function setFinancial_values(\StructType\BelgianBusinessFinancialValues $financial_values = null)
    {
        $this->financial_values = $financial_values;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BelgianBusinessAnnualFinancialStatement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
