<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessDossierErrors StructType
 * @subpackage Structs
 */
class BelgianBusinessDossierErrors extends AbstractStructBase
{
    /**
     * The bank_accounts_error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $bank_accounts_error;
    /**
     * The annual_financial_statements_error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $annual_financial_statements_error;
    /**
     * The legal_representative_companies_error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $legal_representative_companies_error;
    /**
     * The legal_representatives_error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $legal_representatives_error;
    /**
     * The stakeholders_error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $stakeholders_error;
    /**
     * Constructor method for BelgianBusinessDossierErrors
     * @uses BelgianBusinessDossierErrors::setBank_accounts_error()
     * @uses BelgianBusinessDossierErrors::setAnnual_financial_statements_error()
     * @uses BelgianBusinessDossierErrors::setLegal_representative_companies_error()
     * @uses BelgianBusinessDossierErrors::setLegal_representatives_error()
     * @uses BelgianBusinessDossierErrors::setStakeholders_error()
     * @param string $bank_accounts_error
     * @param string $annual_financial_statements_error
     * @param string $legal_representative_companies_error
     * @param string $legal_representatives_error
     * @param string $stakeholders_error
     */
    public function __construct($bank_accounts_error = null, $annual_financial_statements_error = null, $legal_representative_companies_error = null, $legal_representatives_error = null, $stakeholders_error = null)
    {
        $this
            ->setBank_accounts_error($bank_accounts_error)
            ->setAnnual_financial_statements_error($annual_financial_statements_error)
            ->setLegal_representative_companies_error($legal_representative_companies_error)
            ->setLegal_representatives_error($legal_representatives_error)
            ->setStakeholders_error($stakeholders_error);
    }
    /**
     * Get bank_accounts_error value
     * @return string|null
     */
    public function getBank_accounts_error()
    {
        return $this->bank_accounts_error;
    }
    /**
     * Set bank_accounts_error value
     * @param string $bank_accounts_error
     * @return \StructType\BelgianBusinessDossierErrors
     */
    public function setBank_accounts_error($bank_accounts_error = null)
    {
        // validation for constraint: string
        if (!is_null($bank_accounts_error) && !is_string($bank_accounts_error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bank_accounts_error, true), gettype($bank_accounts_error)), __LINE__);
        }
        $this->bank_accounts_error = $bank_accounts_error;
        return $this;
    }
    /**
     * Get annual_financial_statements_error value
     * @return string|null
     */
    public function getAnnual_financial_statements_error()
    {
        return $this->annual_financial_statements_error;
    }
    /**
     * Set annual_financial_statements_error value
     * @param string $annual_financial_statements_error
     * @return \StructType\BelgianBusinessDossierErrors
     */
    public function setAnnual_financial_statements_error($annual_financial_statements_error = null)
    {
        // validation for constraint: string
        if (!is_null($annual_financial_statements_error) && !is_string($annual_financial_statements_error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($annual_financial_statements_error, true), gettype($annual_financial_statements_error)), __LINE__);
        }
        $this->annual_financial_statements_error = $annual_financial_statements_error;
        return $this;
    }
    /**
     * Get legal_representative_companies_error value
     * @return string|null
     */
    public function getLegal_representative_companies_error()
    {
        return $this->legal_representative_companies_error;
    }
    /**
     * Set legal_representative_companies_error value
     * @param string $legal_representative_companies_error
     * @return \StructType\BelgianBusinessDossierErrors
     */
    public function setLegal_representative_companies_error($legal_representative_companies_error = null)
    {
        // validation for constraint: string
        if (!is_null($legal_representative_companies_error) && !is_string($legal_representative_companies_error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_representative_companies_error, true), gettype($legal_representative_companies_error)), __LINE__);
        }
        $this->legal_representative_companies_error = $legal_representative_companies_error;
        return $this;
    }
    /**
     * Get legal_representatives_error value
     * @return string|null
     */
    public function getLegal_representatives_error()
    {
        return $this->legal_representatives_error;
    }
    /**
     * Set legal_representatives_error value
     * @param string $legal_representatives_error
     * @return \StructType\BelgianBusinessDossierErrors
     */
    public function setLegal_representatives_error($legal_representatives_error = null)
    {
        // validation for constraint: string
        if (!is_null($legal_representatives_error) && !is_string($legal_representatives_error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_representatives_error, true), gettype($legal_representatives_error)), __LINE__);
        }
        $this->legal_representatives_error = $legal_representatives_error;
        return $this;
    }
    /**
     * Get stakeholders_error value
     * @return string|null
     */
    public function getStakeholders_error()
    {
        return $this->stakeholders_error;
    }
    /**
     * Set stakeholders_error value
     * @param string $stakeholders_error
     * @return \StructType\BelgianBusinessDossierErrors
     */
    public function setStakeholders_error($stakeholders_error = null)
    {
        // validation for constraint: string
        if (!is_null($stakeholders_error) && !is_string($stakeholders_error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stakeholders_error, true), gettype($stakeholders_error)), __LINE__);
        }
        $this->stakeholders_error = $stakeholders_error;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BelgianBusinessDossierErrors
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
