<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BerichtObjectResultaat StructType
 * @subpackage Structs
 */
class BerichtObjectResultaat extends AbstractStructBase
{
    /**
     * The overzicht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Overzicht
     */
    public $overzicht;
    /**
     * The eigendomsbericht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BerichtObject
     */
    public $eigendomsbericht;
    /**
     * Constructor method for BerichtObjectResultaat
     * @uses BerichtObjectResultaat::setOverzicht()
     * @uses BerichtObjectResultaat::setEigendomsbericht()
     * @param \StructType\Overzicht $overzicht
     * @param \StructType\BerichtObject $eigendomsbericht
     */
    public function __construct(\StructType\Overzicht $overzicht = null, \StructType\BerichtObject $eigendomsbericht = null)
    {
        $this
            ->setOverzicht($overzicht)
            ->setEigendomsbericht($eigendomsbericht);
    }
    /**
     * Get overzicht value
     * @return \StructType\Overzicht|null
     */
    public function getOverzicht()
    {
        return $this->overzicht;
    }
    /**
     * Set overzicht value
     * @param \StructType\Overzicht $overzicht
     * @return \StructType\BerichtObjectResultaat
     */
    public function setOverzicht(\StructType\Overzicht $overzicht = null)
    {
        $this->overzicht = $overzicht;
        return $this;
    }
    /**
     * Get eigendomsbericht value
     * @return \StructType\BerichtObject|null
     */
    public function getEigendomsbericht()
    {
        return $this->eigendomsbericht;
    }
    /**
     * Set eigendomsbericht value
     * @param \StructType\BerichtObject $eigendomsbericht
     * @return \StructType\BerichtObjectResultaat
     */
    public function setEigendomsbericht(\StructType\BerichtObject $eigendomsbericht = null)
    {
        $this->eigendomsbericht = $eigendomsbericht;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BerichtObjectResultaat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
