<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BusinessBIKCodeInfo StructType
 * @subpackage Structs
 */
class BusinessBIKCodeInfo extends AbstractStructBase
{
    /**
     * The sections
     * @var \ArrayType\BusinessBIKSectionArray
     */
    public $sections;
    /**
     * The bikcodes
     * @var \ArrayType\BusinessBIKCodeArray
     */
    public $bikcodes;
    /**
     * Constructor method for BusinessBIKCodeInfo
     * @uses BusinessBIKCodeInfo::setSections()
     * @uses BusinessBIKCodeInfo::setBikcodes()
     * @param \ArrayType\BusinessBIKSectionArray $sections
     * @param \ArrayType\BusinessBIKCodeArray $bikcodes
     */
    public function __construct(\ArrayType\BusinessBIKSectionArray $sections = null, \ArrayType\BusinessBIKCodeArray $bikcodes = null)
    {
        $this
            ->setSections($sections)
            ->setBikcodes($bikcodes);
    }
    /**
     * Get sections value
     * @return \ArrayType\BusinessBIKSectionArray|null
     */
    public function getSections()
    {
        return $this->sections;
    }
    /**
     * Set sections value
     * @param \ArrayType\BusinessBIKSectionArray $sections
     * @return \StructType\BusinessBIKCodeInfo
     */
    public function setSections(\ArrayType\BusinessBIKSectionArray $sections = null)
    {
        $this->sections = $sections;
        return $this;
    }
    /**
     * Get bikcodes value
     * @return \ArrayType\BusinessBIKCodeArray|null
     */
    public function getBikcodes()
    {
        return $this->bikcodes;
    }
    /**
     * Set bikcodes value
     * @param \ArrayType\BusinessBIKCodeArray $bikcodes
     * @return \StructType\BusinessBIKCodeInfo
     */
    public function setBikcodes(\ArrayType\BusinessBIKCodeArray $bikcodes = null)
    {
        $this->bikcodes = $bikcodes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BusinessBIKCodeInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
