<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarVWEOptionsManufacture StructType
 * @subpackage Structs
 */
class CarVWEOptionsManufacture extends AbstractStructBase
{
    /**
     * The license_plate
     * @var string
     */
    public $license_plate;
    /**
     * The atl_code
     * @var int
     */
    public $atl_code;
    /**
     * The options
     * @var \ArrayType\CarVWEOptionArray
     */
    public $options;
    /**
     * Constructor method for CarVWEOptionsManufacture
     * @uses CarVWEOptionsManufacture::setLicense_plate()
     * @uses CarVWEOptionsManufacture::setAtl_code()
     * @uses CarVWEOptionsManufacture::setOptions()
     * @param string $license_plate
     * @param int $atl_code
     * @param \ArrayType\CarVWEOptionArray $options
     */
    public function __construct($license_plate = null, $atl_code = null, \ArrayType\CarVWEOptionArray $options = null)
    {
        $this
            ->setLicense_plate($license_plate)
            ->setAtl_code($atl_code)
            ->setOptions($options);
    }
    /**
     * Get license_plate value
     * @return string|null
     */
    public function getLicense_plate()
    {
        return $this->license_plate;
    }
    /**
     * Set license_plate value
     * @param string $license_plate
     * @return \StructType\CarVWEOptionsManufacture
     */
    public function setLicense_plate($license_plate = null)
    {
        // validation for constraint: string
        if (!is_null($license_plate) && !is_string($license_plate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($license_plate, true), gettype($license_plate)), __LINE__);
        }
        $this->license_plate = $license_plate;
        return $this;
    }
    /**
     * Get atl_code value
     * @return int|null
     */
    public function getAtl_code()
    {
        return $this->atl_code;
    }
    /**
     * Set atl_code value
     * @param int $atl_code
     * @return \StructType\CarVWEOptionsManufacture
     */
    public function setAtl_code($atl_code = null)
    {
        // validation for constraint: int
        if (!is_null($atl_code) && !(is_int($atl_code) || ctype_digit($atl_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($atl_code, true), gettype($atl_code)), __LINE__);
        }
        $this->atl_code = $atl_code;
        return $this;
    }
    /**
     * Get options value
     * @return \ArrayType\CarVWEOptionArray|null
     */
    public function getOptions()
    {
        return $this->options;
    }
    /**
     * Set options value
     * @param \ArrayType\CarVWEOptionArray $options
     * @return \StructType\CarVWEOptionsManufacture
     */
    public function setOptions(\ArrayType\CarVWEOptionArray $options = null)
    {
        $this->options = $options;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CarVWEOptionsManufacture
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
