<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyAdditionalInformationCommentV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyAdditionalInformationCommentV2 extends AbstractStructBase
{
    /**
     * The text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $text;
    /**
     * The sentiment
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sentiment;
    /**
     * Constructor method for CreditsafeCompanyAdditionalInformationCommentV2
     * @uses CreditsafeCompanyAdditionalInformationCommentV2::setText()
     * @uses CreditsafeCompanyAdditionalInformationCommentV2::setSentiment()
     * @param string $text
     * @param string $sentiment
     */
    public function __construct($text = null, $sentiment = null)
    {
        $this
            ->setText($text)
            ->setSentiment($sentiment);
    }
    /**
     * Get text value
     * @return string|null
     */
    public function getText()
    {
        return $this->text;
    }
    /**
     * Set text value
     * @param string $text
     * @return \StructType\CreditsafeCompanyAdditionalInformationCommentV2
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        $this->text = $text;
        return $this;
    }
    /**
     * Get sentiment value
     * @return string|null
     */
    public function getSentiment()
    {
        return $this->sentiment;
    }
    /**
     * Set sentiment value
     * @param string $sentiment
     * @return \StructType\CreditsafeCompanyAdditionalInformationCommentV2
     */
    public function setSentiment($sentiment = null)
    {
        // validation for constraint: string
        if (!is_null($sentiment) && !is_string($sentiment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sentiment, true), gettype($sentiment)), __LINE__);
        }
        $this->sentiment = $sentiment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyAdditionalInformationCommentV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
