<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
 * StructType
 * @subpackage Structs
 */
class CreditsafeCompanyAdditionalInformationDEMiscellaneousV2 extends AbstractStructBase
{
    /**
     * The turnover_range
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $turnover_range;
    /**
     * The commercial_register_city
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commercial_register_city;
    /**
     * The commercial_register_zip
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commercial_register_zip;
    /**
     * The financials_quality
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $financials_quality;
    /**
     * The current_rating
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeValueV2
     */
    public $current_rating;
    /**
     * The previous_rating
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeValueV2
     */
    public $previous_rating;
    /**
     * The premise_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premise_type;
    /**
     * The small_office
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $small_office;
    /**
     * The fax_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fax_number;
    /**
     * The company_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $company_type;
    /**
     * The negative_rating
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $negative_rating;
    /**
     * The complementary_company
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $complementary_company;
    /**
     * The business_purpose
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $business_purpose;
    /**
     * Constructor method for CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setTurnover_range()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setCommercial_register_city()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setCommercial_register_zip()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setFinancials_quality()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setCurrent_rating()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setPrevious_rating()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setPremise_type()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setSmall_office()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setFax_number()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setCompany_type()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setNegative_rating()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setComplementary_company()
     * @uses CreditsafeCompanyAdditionalInformationDEMiscellaneousV2::setBusiness_purpose()
     * @param string $turnover_range
     * @param string $commercial_register_city
     * @param string $commercial_register_zip
     * @param string $financials_quality
     * @param \StructType\CreditsafeValueV2 $current_rating
     * @param \StructType\CreditsafeValueV2 $previous_rating
     * @param string $premise_type
     * @param string $small_office
     * @param string $fax_number
     * @param string $company_type
     * @param string $negative_rating
     * @param string $complementary_company
     * @param string $business_purpose
     */
    public function __construct($turnover_range = null, $commercial_register_city = null, $commercial_register_zip = null, $financials_quality = null, \StructType\CreditsafeValueV2 $current_rating = null, \StructType\CreditsafeValueV2 $previous_rating = null, $premise_type = null, $small_office = null, $fax_number = null, $company_type = null, $negative_rating = null, $complementary_company = null, $business_purpose = null)
    {
        $this
            ->setTurnover_range($turnover_range)
            ->setCommercial_register_city($commercial_register_city)
            ->setCommercial_register_zip($commercial_register_zip)
            ->setFinancials_quality($financials_quality)
            ->setCurrent_rating($current_rating)
            ->setPrevious_rating($previous_rating)
            ->setPremise_type($premise_type)
            ->setSmall_office($small_office)
            ->setFax_number($fax_number)
            ->setCompany_type($company_type)
            ->setNegative_rating($negative_rating)
            ->setComplementary_company($complementary_company)
            ->setBusiness_purpose($business_purpose);
    }
    /**
     * Get turnover_range value
     * @return string|null
     */
    public function getTurnover_range()
    {
        return $this->turnover_range;
    }
    /**
     * Set turnover_range value
     * @param string $turnover_range
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setTurnover_range($turnover_range = null)
    {
        // validation for constraint: string
        if (!is_null($turnover_range) && !is_string($turnover_range)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($turnover_range, true), gettype($turnover_range)), __LINE__);
        }
        $this->turnover_range = $turnover_range;
        return $this;
    }
    /**
     * Get commercial_register_city value
     * @return string|null
     */
    public function getCommercial_register_city()
    {
        return $this->commercial_register_city;
    }
    /**
     * Set commercial_register_city value
     * @param string $commercial_register_city
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setCommercial_register_city($commercial_register_city = null)
    {
        // validation for constraint: string
        if (!is_null($commercial_register_city) && !is_string($commercial_register_city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commercial_register_city, true), gettype($commercial_register_city)), __LINE__);
        }
        $this->commercial_register_city = $commercial_register_city;
        return $this;
    }
    /**
     * Get commercial_register_zip value
     * @return string|null
     */
    public function getCommercial_register_zip()
    {
        return $this->commercial_register_zip;
    }
    /**
     * Set commercial_register_zip value
     * @param string $commercial_register_zip
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setCommercial_register_zip($commercial_register_zip = null)
    {
        // validation for constraint: string
        if (!is_null($commercial_register_zip) && !is_string($commercial_register_zip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commercial_register_zip, true), gettype($commercial_register_zip)), __LINE__);
        }
        $this->commercial_register_zip = $commercial_register_zip;
        return $this;
    }
    /**
     * Get financials_quality value
     * @return string|null
     */
    public function getFinancials_quality()
    {
        return $this->financials_quality;
    }
    /**
     * Set financials_quality value
     * @param string $financials_quality
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setFinancials_quality($financials_quality = null)
    {
        // validation for constraint: string
        if (!is_null($financials_quality) && !is_string($financials_quality)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($financials_quality, true), gettype($financials_quality)), __LINE__);
        }
        $this->financials_quality = $financials_quality;
        return $this;
    }
    /**
     * Get current_rating value
     * @return \StructType\CreditsafeValueV2|null
     */
    public function getCurrent_rating()
    {
        return $this->current_rating;
    }
    /**
     * Set current_rating value
     * @param \StructType\CreditsafeValueV2 $current_rating
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setCurrent_rating(\StructType\CreditsafeValueV2 $current_rating = null)
    {
        $this->current_rating = $current_rating;
        return $this;
    }
    /**
     * Get previous_rating value
     * @return \StructType\CreditsafeValueV2|null
     */
    public function getPrevious_rating()
    {
        return $this->previous_rating;
    }
    /**
     * Set previous_rating value
     * @param \StructType\CreditsafeValueV2 $previous_rating
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setPrevious_rating(\StructType\CreditsafeValueV2 $previous_rating = null)
    {
        $this->previous_rating = $previous_rating;
        return $this;
    }
    /**
     * Get premise_type value
     * @return string|null
     */
    public function getPremise_type()
    {
        return $this->premise_type;
    }
    /**
     * Set premise_type value
     * @param string $premise_type
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setPremise_type($premise_type = null)
    {
        // validation for constraint: string
        if (!is_null($premise_type) && !is_string($premise_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premise_type, true), gettype($premise_type)), __LINE__);
        }
        $this->premise_type = $premise_type;
        return $this;
    }
    /**
     * Get small_office value
     * @return string|null
     */
    public function getSmall_office()
    {
        return $this->small_office;
    }
    /**
     * Set small_office value
     * @param string $small_office
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setSmall_office($small_office = null)
    {
        // validation for constraint: string
        if (!is_null($small_office) && !is_string($small_office)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($small_office, true), gettype($small_office)), __LINE__);
        }
        $this->small_office = $small_office;
        return $this;
    }
    /**
     * Get fax_number value
     * @return string|null
     */
    public function getFax_number()
    {
        return $this->fax_number;
    }
    /**
     * Set fax_number value
     * @param string $fax_number
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setFax_number($fax_number = null)
    {
        // validation for constraint: string
        if (!is_null($fax_number) && !is_string($fax_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fax_number, true), gettype($fax_number)), __LINE__);
        }
        $this->fax_number = $fax_number;
        return $this;
    }
    /**
     * Get company_type value
     * @return string|null
     */
    public function getCompany_type()
    {
        return $this->company_type;
    }
    /**
     * Set company_type value
     * @param string $company_type
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setCompany_type($company_type = null)
    {
        // validation for constraint: string
        if (!is_null($company_type) && !is_string($company_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_type, true), gettype($company_type)), __LINE__);
        }
        $this->company_type = $company_type;
        return $this;
    }
    /**
     * Get negative_rating value
     * @return string|null
     */
    public function getNegative_rating()
    {
        return $this->negative_rating;
    }
    /**
     * Set negative_rating value
     * @param string $negative_rating
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setNegative_rating($negative_rating = null)
    {
        // validation for constraint: string
        if (!is_null($negative_rating) && !is_string($negative_rating)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($negative_rating, true), gettype($negative_rating)), __LINE__);
        }
        $this->negative_rating = $negative_rating;
        return $this;
    }
    /**
     * Get complementary_company value
     * @return string|null
     */
    public function getComplementary_company()
    {
        return $this->complementary_company;
    }
    /**
     * Set complementary_company value
     * @param string $complementary_company
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setComplementary_company($complementary_company = null)
    {
        // validation for constraint: string
        if (!is_null($complementary_company) && !is_string($complementary_company)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($complementary_company, true), gettype($complementary_company)), __LINE__);
        }
        $this->complementary_company = $complementary_company;
        return $this;
    }
    /**
     * Get business_purpose value
     * @return string|null
     */
    public function getBusiness_purpose()
    {
        return $this->business_purpose;
    }
    /**
     * Set business_purpose value
     * @param string $business_purpose
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public function setBusiness_purpose($business_purpose = null)
    {
        // validation for constraint: string
        if (!is_null($business_purpose) && !is_string($business_purpose)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($business_purpose, true), gettype($business_purpose)), __LINE__);
        }
        $this->business_purpose = $business_purpose;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyAdditionalInformationDEMiscellaneousV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
