<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyNegativeInformationNLCourtItemV2
 * StructType
 * @subpackage Structs
 */
class CreditsafeCompanyNegativeInformationNLCourtItemV2 extends AbstractStructBase
{
    /**
     * The court_action
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $court_action;
    /**
     * The date_of_bankruptcy
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date_of_bankruptcy;
    /**
     * The address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $address;
    /**
     * Constructor method for CreditsafeCompanyNegativeInformationNLCourtItemV2
     * @uses CreditsafeCompanyNegativeInformationNLCourtItemV2::setCourt_action()
     * @uses CreditsafeCompanyNegativeInformationNLCourtItemV2::setDate_of_bankruptcy()
     * @uses CreditsafeCompanyNegativeInformationNLCourtItemV2::setAddress()
     * @param string $court_action
     * @param string $date_of_bankruptcy
     * @param string $address
     */
    public function __construct($court_action = null, $date_of_bankruptcy = null, $address = null)
    {
        $this
            ->setCourt_action($court_action)
            ->setDate_of_bankruptcy($date_of_bankruptcy)
            ->setAddress($address);
    }
    /**
     * Get court_action value
     * @return string|null
     */
    public function getCourt_action()
    {
        return $this->court_action;
    }
    /**
     * Set court_action value
     * @param string $court_action
     * @return \StructType\CreditsafeCompanyNegativeInformationNLCourtItemV2
     */
    public function setCourt_action($court_action = null)
    {
        // validation for constraint: string
        if (!is_null($court_action) && !is_string($court_action)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($court_action, true), gettype($court_action)), __LINE__);
        }
        $this->court_action = $court_action;
        return $this;
    }
    /**
     * Get date_of_bankruptcy value
     * @return string|null
     */
    public function getDate_of_bankruptcy()
    {
        return $this->date_of_bankruptcy;
    }
    /**
     * Set date_of_bankruptcy value
     * @param string $date_of_bankruptcy
     * @return \StructType\CreditsafeCompanyNegativeInformationNLCourtItemV2
     */
    public function setDate_of_bankruptcy($date_of_bankruptcy = null)
    {
        // validation for constraint: string
        if (!is_null($date_of_bankruptcy) && !is_string($date_of_bankruptcy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_of_bankruptcy, true), gettype($date_of_bankruptcy)), __LINE__);
        }
        $this->date_of_bankruptcy = $date_of_bankruptcy;
        return $this;
    }
    /**
     * Get address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param string $address
     * @return \StructType\CreditsafeCompanyNegativeInformationNLCourtItemV2
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address, true), gettype($address)), __LINE__);
        }
        $this->address = $address;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyNegativeInformationNLCourtItemV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
