<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyOtherInformationV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyOtherInformationV2 extends AbstractStructBase
{
    /**
     * The bankers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeCompanyBankerV2Array
     */
    public $bankers;
    /**
     * The advisors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeCompanyAdvisorV2Array
     */
    public $advisors;
    /**
     * The employees_information
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeCompanyEmployeeInformationV2Array
     */
    public $employees_information;
    /**
     * Constructor method for CreditsafeCompanyOtherInformationV2
     * @uses CreditsafeCompanyOtherInformationV2::setBankers()
     * @uses CreditsafeCompanyOtherInformationV2::setAdvisors()
     * @uses CreditsafeCompanyOtherInformationV2::setEmployees_information()
     * @param \ArrayType\CreditsafeCompanyBankerV2Array $bankers
     * @param \ArrayType\CreditsafeCompanyAdvisorV2Array $advisors
     * @param \ArrayType\CreditsafeCompanyEmployeeInformationV2Array $employees_information
     */
    public function __construct(\ArrayType\CreditsafeCompanyBankerV2Array $bankers = null, \ArrayType\CreditsafeCompanyAdvisorV2Array $advisors = null, \ArrayType\CreditsafeCompanyEmployeeInformationV2Array $employees_information = null)
    {
        $this
            ->setBankers($bankers)
            ->setAdvisors($advisors)
            ->setEmployees_information($employees_information);
    }
    /**
     * Get bankers value
     * @return \ArrayType\CreditsafeCompanyBankerV2Array|null
     */
    public function getBankers()
    {
        return $this->bankers;
    }
    /**
     * Set bankers value
     * @param \ArrayType\CreditsafeCompanyBankerV2Array $bankers
     * @return \StructType\CreditsafeCompanyOtherInformationV2
     */
    public function setBankers(\ArrayType\CreditsafeCompanyBankerV2Array $bankers = null)
    {
        $this->bankers = $bankers;
        return $this;
    }
    /**
     * Get advisors value
     * @return \ArrayType\CreditsafeCompanyAdvisorV2Array|null
     */
    public function getAdvisors()
    {
        return $this->advisors;
    }
    /**
     * Set advisors value
     * @param \ArrayType\CreditsafeCompanyAdvisorV2Array $advisors
     * @return \StructType\CreditsafeCompanyOtherInformationV2
     */
    public function setAdvisors(\ArrayType\CreditsafeCompanyAdvisorV2Array $advisors = null)
    {
        $this->advisors = $advisors;
        return $this;
    }
    /**
     * Get employees_information value
     * @return \ArrayType\CreditsafeCompanyEmployeeInformationV2Array|null
     */
    public function getEmployees_information()
    {
        return $this->employees_information;
    }
    /**
     * Set employees_information value
     * @param \ArrayType\CreditsafeCompanyEmployeeInformationV2Array $employees_information
     * @return \StructType\CreditsafeCompanyOtherInformationV2
     */
    public function setEmployees_information(\ArrayType\CreditsafeCompanyEmployeeInformationV2Array $employees_information = null)
    {
        $this->employees_information = $employees_information;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyOtherInformationV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
