<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyShareHolderV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyShareHolderV2 extends AbstractStructBase
{
    /**
     * The address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeAddressV2
     */
    public $address;
    /**
     * The share_percent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $share_percent;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * Constructor method for CreditsafeCompanyShareHolderV2
     * @uses CreditsafeCompanyShareHolderV2::setAddress()
     * @uses CreditsafeCompanyShareHolderV2::setShare_percent()
     * @uses CreditsafeCompanyShareHolderV2::setName()
     * @param \StructType\CreditsafeAddressV2 $address
     * @param int $share_percent
     * @param string $name
     */
    public function __construct(\StructType\CreditsafeAddressV2 $address = null, $share_percent = null, $name = null)
    {
        $this
            ->setAddress($address)
            ->setShare_percent($share_percent)
            ->setName($name);
    }
    /**
     * Get address value
     * @return \StructType\CreditsafeAddressV2|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param \StructType\CreditsafeAddressV2 $address
     * @return \StructType\CreditsafeCompanyShareHolderV2
     */
    public function setAddress(\StructType\CreditsafeAddressV2 $address = null)
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Get share_percent value
     * @return int|null
     */
    public function getShare_percent()
    {
        return $this->share_percent;
    }
    /**
     * Set share_percent value
     * @param int $share_percent
     * @return \StructType\CreditsafeCompanyShareHolderV2
     */
    public function setShare_percent($share_percent = null)
    {
        // validation for constraint: int
        if (!is_null($share_percent) && !(is_int($share_percent) || ctype_digit($share_percent))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($share_percent, true), gettype($share_percent)), __LINE__);
        }
        $this->share_percent = $share_percent;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\CreditsafeCompanyShareHolderV2
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyShareHolderV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
