<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeLtdContactInformation StructType
 * @subpackage Structs
 */
class CreditsafeLtdContactInformation extends AbstractStructBase
{
    /**
     * The main_address
     * @var \StructType\CreditsafeStreetAddressWithTelephone
     */
    public $main_address;
    /**
     * The other_addresses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeStreetAddressWithTelephoneArray
     */
    public $other_addresses;
    /**
     * The previous_addresses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeStreetAddressArray
     */
    public $previous_addresses;
    /**
     * The email_addresses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $email_addresses;
    /**
     * The websites
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $websites;
    /**
     * Constructor method for CreditsafeLtdContactInformation
     * @uses CreditsafeLtdContactInformation::setMain_address()
     * @uses CreditsafeLtdContactInformation::setOther_addresses()
     * @uses CreditsafeLtdContactInformation::setPrevious_addresses()
     * @uses CreditsafeLtdContactInformation::setEmail_addresses()
     * @uses CreditsafeLtdContactInformation::setWebsites()
     * @param \StructType\CreditsafeStreetAddressWithTelephone $main_address
     * @param \ArrayType\CreditsafeStreetAddressWithTelephoneArray $other_addresses
     * @param \ArrayType\CreditsafeStreetAddressArray $previous_addresses
     * @param \ArrayType\StringArray $email_addresses
     * @param \ArrayType\StringArray $websites
     */
    public function __construct(\StructType\CreditsafeStreetAddressWithTelephone $main_address = null, \ArrayType\CreditsafeStreetAddressWithTelephoneArray $other_addresses = null, \ArrayType\CreditsafeStreetAddressArray $previous_addresses = null, \ArrayType\StringArray $email_addresses = null, \ArrayType\StringArray $websites = null)
    {
        $this
            ->setMain_address($main_address)
            ->setOther_addresses($other_addresses)
            ->setPrevious_addresses($previous_addresses)
            ->setEmail_addresses($email_addresses)
            ->setWebsites($websites);
    }
    /**
     * Get main_address value
     * @return \StructType\CreditsafeStreetAddressWithTelephone|null
     */
    public function getMain_address()
    {
        return $this->main_address;
    }
    /**
     * Set main_address value
     * @param \StructType\CreditsafeStreetAddressWithTelephone $main_address
     * @return \StructType\CreditsafeLtdContactInformation
     */
    public function setMain_address(\StructType\CreditsafeStreetAddressWithTelephone $main_address = null)
    {
        $this->main_address = $main_address;
        return $this;
    }
    /**
     * Get other_addresses value
     * @return \ArrayType\CreditsafeStreetAddressWithTelephoneArray|null
     */
    public function getOther_addresses()
    {
        return $this->other_addresses;
    }
    /**
     * Set other_addresses value
     * @param \ArrayType\CreditsafeStreetAddressWithTelephoneArray $other_addresses
     * @return \StructType\CreditsafeLtdContactInformation
     */
    public function setOther_addresses(\ArrayType\CreditsafeStreetAddressWithTelephoneArray $other_addresses = null)
    {
        $this->other_addresses = $other_addresses;
        return $this;
    }
    /**
     * Get previous_addresses value
     * @return \ArrayType\CreditsafeStreetAddressArray|null
     */
    public function getPrevious_addresses()
    {
        return $this->previous_addresses;
    }
    /**
     * Set previous_addresses value
     * @param \ArrayType\CreditsafeStreetAddressArray $previous_addresses
     * @return \StructType\CreditsafeLtdContactInformation
     */
    public function setPrevious_addresses(\ArrayType\CreditsafeStreetAddressArray $previous_addresses = null)
    {
        $this->previous_addresses = $previous_addresses;
        return $this;
    }
    /**
     * Get email_addresses value
     * @return \ArrayType\StringArray|null
     */
    public function getEmail_addresses()
    {
        return $this->email_addresses;
    }
    /**
     * Set email_addresses value
     * @param \ArrayType\StringArray $email_addresses
     * @return \StructType\CreditsafeLtdContactInformation
     */
    public function setEmail_addresses(\ArrayType\StringArray $email_addresses = null)
    {
        $this->email_addresses = $email_addresses;
        return $this;
    }
    /**
     * Get websites value
     * @return \ArrayType\StringArray|null
     */
    public function getWebsites()
    {
        return $this->websites;
    }
    /**
     * Set websites value
     * @param \ArrayType\StringArray $websites
     * @return \StructType\CreditsafeLtdContactInformation
     */
    public function setWebsites(\ArrayType\StringArray $websites = null)
    {
        $this->websites = $websites;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeLtdContactInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
