<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeValueV2 StructType
 * @subpackage Structs
 */
class CreditsafeValueV2 extends AbstractStructBase
{
    /**
     * The max_value
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $max_value;
    /**
     * The min_value
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $min_value;
    /**
     * The value
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $value;
    /**
     * Constructor method for CreditsafeValueV2
     * @uses CreditsafeValueV2::setMax_value()
     * @uses CreditsafeValueV2::setMin_value()
     * @uses CreditsafeValueV2::setValue()
     * @param string $max_value
     * @param string $min_value
     * @param string $value
     */
    public function __construct($max_value = null, $min_value = null, $value = null)
    {
        $this
            ->setMax_value($max_value)
            ->setMin_value($min_value)
            ->setValue($value);
    }
    /**
     * Get max_value value
     * @return string|null
     */
    public function getMax_value()
    {
        return $this->max_value;
    }
    /**
     * Set max_value value
     * @param string $max_value
     * @return \StructType\CreditsafeValueV2
     */
    public function setMax_value($max_value = null)
    {
        // validation for constraint: string
        if (!is_null($max_value) && !is_string($max_value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($max_value, true), gettype($max_value)), __LINE__);
        }
        $this->max_value = $max_value;
        return $this;
    }
    /**
     * Get min_value value
     * @return string|null
     */
    public function getMin_value()
    {
        return $this->min_value;
    }
    /**
     * Set min_value value
     * @param string $min_value
     * @return \StructType\CreditsafeValueV2
     */
    public function setMin_value($min_value = null)
    {
        // validation for constraint: string
        if (!is_null($min_value) && !is_string($min_value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($min_value, true), gettype($min_value)), __LINE__);
        }
        $this->min_value = $min_value;
        return $this;
    }
    /**
     * Get value value
     * @return string|null
     */
    public function getValue()
    {
        return $this->value;
    }
    /**
     * Set value value
     * @param string $value
     * @return \StructType\CreditsafeValueV2
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->value = $value;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeValueV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
