<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessEstablishmentV2 StructType
 * @subpackage Structs
 */
class DutchBusinessEstablishmentV2 extends AbstractStructBase
{
    /**
     * The establishment_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $establishment_number;
    /**
     * The main_establishment
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $main_establishment;
    /**
     * The legal_form_text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $legal_form_text;
    /**
     * The activity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $activity;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The establishment_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV2
     */
    public $establishment_date;
    /**
     * The date_since
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV2
     */
    public $date_since;
    /**
     * The personnel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessPersonnelInfoV2
     */
    public $personnel;
    /**
     * The remarks
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $remarks;
    /**
     * The sbi_codes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchBusinessSbiCodeV2Array
     */
    public $sbi_codes;
    /**
     * The establishment_address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessAddressV2
     */
    public $establishment_address;
    /**
     * The correspondence_address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessAddressV2
     */
    public $correspondence_address;
    /**
     * The telephone_numbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $telephone_numbers;
    /**
     * The fax_numbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $fax_numbers;
    /**
     * The email_addresses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $email_addresses;
    /**
     * The domain_names
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $domain_names;
    /**
     * The trade_names
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $trade_names;
    /**
     * Constructor method for DutchBusinessEstablishmentV2
     * @uses DutchBusinessEstablishmentV2::setEstablishment_number()
     * @uses DutchBusinessEstablishmentV2::setMain_establishment()
     * @uses DutchBusinessEstablishmentV2::setLegal_form_text()
     * @uses DutchBusinessEstablishmentV2::setActivity()
     * @uses DutchBusinessEstablishmentV2::setDescription()
     * @uses DutchBusinessEstablishmentV2::setEstablishment_date()
     * @uses DutchBusinessEstablishmentV2::setDate_since()
     * @uses DutchBusinessEstablishmentV2::setPersonnel()
     * @uses DutchBusinessEstablishmentV2::setRemarks()
     * @uses DutchBusinessEstablishmentV2::setSbi_codes()
     * @uses DutchBusinessEstablishmentV2::setEstablishment_address()
     * @uses DutchBusinessEstablishmentV2::setCorrespondence_address()
     * @uses DutchBusinessEstablishmentV2::setTelephone_numbers()
     * @uses DutchBusinessEstablishmentV2::setFax_numbers()
     * @uses DutchBusinessEstablishmentV2::setEmail_addresses()
     * @uses DutchBusinessEstablishmentV2::setDomain_names()
     * @uses DutchBusinessEstablishmentV2::setTrade_names()
     * @param string $establishment_number
     * @param bool $main_establishment
     * @param string $legal_form_text
     * @param string $activity
     * @param string $description
     * @param \StructType\DutchBusinessDateV2 $establishment_date
     * @param \StructType\DutchBusinessDateV2 $date_since
     * @param \StructType\DutchBusinessPersonnelInfoV2 $personnel
     * @param \ArrayType\StringArray $remarks
     * @param \ArrayType\DutchBusinessSbiCodeV2Array $sbi_codes
     * @param \StructType\DutchBusinessAddressV2 $establishment_address
     * @param \StructType\DutchBusinessAddressV2 $correspondence_address
     * @param \ArrayType\StringArray $telephone_numbers
     * @param \ArrayType\StringArray $fax_numbers
     * @param \ArrayType\StringArray $email_addresses
     * @param \ArrayType\StringArray $domain_names
     * @param \ArrayType\StringArray $trade_names
     */
    public function __construct($establishment_number = null, $main_establishment = null, $legal_form_text = null, $activity = null, $description = null, \StructType\DutchBusinessDateV2 $establishment_date = null, \StructType\DutchBusinessDateV2 $date_since = null, \StructType\DutchBusinessPersonnelInfoV2 $personnel = null, \ArrayType\StringArray $remarks = null, \ArrayType\DutchBusinessSbiCodeV2Array $sbi_codes = null, \StructType\DutchBusinessAddressV2 $establishment_address = null, \StructType\DutchBusinessAddressV2 $correspondence_address = null, \ArrayType\StringArray $telephone_numbers = null, \ArrayType\StringArray $fax_numbers = null, \ArrayType\StringArray $email_addresses = null, \ArrayType\StringArray $domain_names = null, \ArrayType\StringArray $trade_names = null)
    {
        $this
            ->setEstablishment_number($establishment_number)
            ->setMain_establishment($main_establishment)
            ->setLegal_form_text($legal_form_text)
            ->setActivity($activity)
            ->setDescription($description)
            ->setEstablishment_date($establishment_date)
            ->setDate_since($date_since)
            ->setPersonnel($personnel)
            ->setRemarks($remarks)
            ->setSbi_codes($sbi_codes)
            ->setEstablishment_address($establishment_address)
            ->setCorrespondence_address($correspondence_address)
            ->setTelephone_numbers($telephone_numbers)
            ->setFax_numbers($fax_numbers)
            ->setEmail_addresses($email_addresses)
            ->setDomain_names($domain_names)
            ->setTrade_names($trade_names);
    }
    /**
     * Get establishment_number value
     * @return string|null
     */
    public function getEstablishment_number()
    {
        return $this->establishment_number;
    }
    /**
     * Set establishment_number value
     * @param string $establishment_number
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setEstablishment_number($establishment_number = null)
    {
        // validation for constraint: string
        if (!is_null($establishment_number) && !is_string($establishment_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($establishment_number, true), gettype($establishment_number)), __LINE__);
        }
        $this->establishment_number = $establishment_number;
        return $this;
    }
    /**
     * Get main_establishment value
     * @return bool|null
     */
    public function getMain_establishment()
    {
        return $this->main_establishment;
    }
    /**
     * Set main_establishment value
     * @param bool $main_establishment
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setMain_establishment($main_establishment = null)
    {
        // validation for constraint: boolean
        if (!is_null($main_establishment) && !is_bool($main_establishment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($main_establishment, true), gettype($main_establishment)), __LINE__);
        }
        $this->main_establishment = $main_establishment;
        return $this;
    }
    /**
     * Get legal_form_text value
     * @return string|null
     */
    public function getLegal_form_text()
    {
        return $this->legal_form_text;
    }
    /**
     * Set legal_form_text value
     * @param string $legal_form_text
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setLegal_form_text($legal_form_text = null)
    {
        // validation for constraint: string
        if (!is_null($legal_form_text) && !is_string($legal_form_text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_form_text, true), gettype($legal_form_text)), __LINE__);
        }
        $this->legal_form_text = $legal_form_text;
        return $this;
    }
    /**
     * Get activity value
     * @return string|null
     */
    public function getActivity()
    {
        return $this->activity;
    }
    /**
     * Set activity value
     * @param string $activity
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setActivity($activity = null)
    {
        // validation for constraint: string
        if (!is_null($activity) && !is_string($activity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($activity, true), gettype($activity)), __LINE__);
        }
        $this->activity = $activity;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get establishment_date value
     * @return \StructType\DutchBusinessDateV2|null
     */
    public function getEstablishment_date()
    {
        return $this->establishment_date;
    }
    /**
     * Set establishment_date value
     * @param \StructType\DutchBusinessDateV2 $establishment_date
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setEstablishment_date(\StructType\DutchBusinessDateV2 $establishment_date = null)
    {
        $this->establishment_date = $establishment_date;
        return $this;
    }
    /**
     * Get date_since value
     * @return \StructType\DutchBusinessDateV2|null
     */
    public function getDate_since()
    {
        return $this->date_since;
    }
    /**
     * Set date_since value
     * @param \StructType\DutchBusinessDateV2 $date_since
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setDate_since(\StructType\DutchBusinessDateV2 $date_since = null)
    {
        $this->date_since = $date_since;
        return $this;
    }
    /**
     * Get personnel value
     * @return \StructType\DutchBusinessPersonnelInfoV2|null
     */
    public function getPersonnel()
    {
        return $this->personnel;
    }
    /**
     * Set personnel value
     * @param \StructType\DutchBusinessPersonnelInfoV2 $personnel
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setPersonnel(\StructType\DutchBusinessPersonnelInfoV2 $personnel = null)
    {
        $this->personnel = $personnel;
        return $this;
    }
    /**
     * Get remarks value
     * @return \ArrayType\StringArray|null
     */
    public function getRemarks()
    {
        return $this->remarks;
    }
    /**
     * Set remarks value
     * @param \ArrayType\StringArray $remarks
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setRemarks(\ArrayType\StringArray $remarks = null)
    {
        $this->remarks = $remarks;
        return $this;
    }
    /**
     * Get sbi_codes value
     * @return \ArrayType\DutchBusinessSbiCodeV2Array|null
     */
    public function getSbi_codes()
    {
        return $this->sbi_codes;
    }
    /**
     * Set sbi_codes value
     * @param \ArrayType\DutchBusinessSbiCodeV2Array $sbi_codes
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setSbi_codes(\ArrayType\DutchBusinessSbiCodeV2Array $sbi_codes = null)
    {
        $this->sbi_codes = $sbi_codes;
        return $this;
    }
    /**
     * Get establishment_address value
     * @return \StructType\DutchBusinessAddressV2|null
     */
    public function getEstablishment_address()
    {
        return $this->establishment_address;
    }
    /**
     * Set establishment_address value
     * @param \StructType\DutchBusinessAddressV2 $establishment_address
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setEstablishment_address(\StructType\DutchBusinessAddressV2 $establishment_address = null)
    {
        $this->establishment_address = $establishment_address;
        return $this;
    }
    /**
     * Get correspondence_address value
     * @return \StructType\DutchBusinessAddressV2|null
     */
    public function getCorrespondence_address()
    {
        return $this->correspondence_address;
    }
    /**
     * Set correspondence_address value
     * @param \StructType\DutchBusinessAddressV2 $correspondence_address
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setCorrespondence_address(\StructType\DutchBusinessAddressV2 $correspondence_address = null)
    {
        $this->correspondence_address = $correspondence_address;
        return $this;
    }
    /**
     * Get telephone_numbers value
     * @return \ArrayType\StringArray|null
     */
    public function getTelephone_numbers()
    {
        return $this->telephone_numbers;
    }
    /**
     * Set telephone_numbers value
     * @param \ArrayType\StringArray $telephone_numbers
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setTelephone_numbers(\ArrayType\StringArray $telephone_numbers = null)
    {
        $this->telephone_numbers = $telephone_numbers;
        return $this;
    }
    /**
     * Get fax_numbers value
     * @return \ArrayType\StringArray|null
     */
    public function getFax_numbers()
    {
        return $this->fax_numbers;
    }
    /**
     * Set fax_numbers value
     * @param \ArrayType\StringArray $fax_numbers
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setFax_numbers(\ArrayType\StringArray $fax_numbers = null)
    {
        $this->fax_numbers = $fax_numbers;
        return $this;
    }
    /**
     * Get email_addresses value
     * @return \ArrayType\StringArray|null
     */
    public function getEmail_addresses()
    {
        return $this->email_addresses;
    }
    /**
     * Set email_addresses value
     * @param \ArrayType\StringArray $email_addresses
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setEmail_addresses(\ArrayType\StringArray $email_addresses = null)
    {
        $this->email_addresses = $email_addresses;
        return $this;
    }
    /**
     * Get domain_names value
     * @return \ArrayType\StringArray|null
     */
    public function getDomain_names()
    {
        return $this->domain_names;
    }
    /**
     * Set domain_names value
     * @param \ArrayType\StringArray $domain_names
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setDomain_names(\ArrayType\StringArray $domain_names = null)
    {
        $this->domain_names = $domain_names;
        return $this;
    }
    /**
     * Get trade_names value
     * @return \ArrayType\StringArray|null
     */
    public function getTrade_names()
    {
        return $this->trade_names;
    }
    /**
     * Set trade_names value
     * @param \ArrayType\StringArray $trade_names
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public function setTrade_names(\ArrayType\StringArray $trade_names = null)
    {
        $this->trade_names = $trade_names;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessEstablishmentV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
