<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessExtractDataV3 StructType
 * @subpackage Structs
 */
class DutchBusinessExtractDataV3 extends AbstractStructBase
{
    /**
     * The dossier_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dossier_number;
    /**
     * The reference_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $reference_date;
    /**
     * The legal_entity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessLegalEntityV3
     */
    public $legal_entity;
    /**
     * The partnership
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessPartnershipV3
     */
    public $partnership;
    /**
     * The enterprise
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessEnterpriseV3
     */
    public $enterprise;
    /**
     * The establishments
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchBusinessEstablishmentV3Array
     */
    public $establishments;
    /**
     * The positions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchBusinessPositionV3Array
     */
    public $positions;
    /**
     * The remarks
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $remarks;
    /**
     * Constructor method for DutchBusinessExtractDataV3
     * @uses DutchBusinessExtractDataV3::setDossier_number()
     * @uses DutchBusinessExtractDataV3::setReference_date()
     * @uses DutchBusinessExtractDataV3::setLegal_entity()
     * @uses DutchBusinessExtractDataV3::setPartnership()
     * @uses DutchBusinessExtractDataV3::setEnterprise()
     * @uses DutchBusinessExtractDataV3::setEstablishments()
     * @uses DutchBusinessExtractDataV3::setPositions()
     * @uses DutchBusinessExtractDataV3::setRemarks()
     * @param string $dossier_number
     * @param string $reference_date
     * @param \StructType\DutchBusinessLegalEntityV3 $legal_entity
     * @param \StructType\DutchBusinessPartnershipV3 $partnership
     * @param \StructType\DutchBusinessEnterpriseV3 $enterprise
     * @param \ArrayType\DutchBusinessEstablishmentV3Array $establishments
     * @param \ArrayType\DutchBusinessPositionV3Array $positions
     * @param \ArrayType\StringArray $remarks
     */
    public function __construct($dossier_number = null, $reference_date = null, \StructType\DutchBusinessLegalEntityV3 $legal_entity = null, \StructType\DutchBusinessPartnershipV3 $partnership = null, \StructType\DutchBusinessEnterpriseV3 $enterprise = null, \ArrayType\DutchBusinessEstablishmentV3Array $establishments = null, \ArrayType\DutchBusinessPositionV3Array $positions = null, \ArrayType\StringArray $remarks = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setReference_date($reference_date)
            ->setLegal_entity($legal_entity)
            ->setPartnership($partnership)
            ->setEnterprise($enterprise)
            ->setEstablishments($establishments)
            ->setPositions($positions)
            ->setRemarks($remarks);
    }
    /**
     * Get dossier_number value
     * @return string|null
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get reference_date value
     * @return string|null
     */
    public function getReference_date()
    {
        return $this->reference_date;
    }
    /**
     * Set reference_date value
     * @param string $reference_date
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setReference_date($reference_date = null)
    {
        // validation for constraint: string
        if (!is_null($reference_date) && !is_string($reference_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference_date, true), gettype($reference_date)), __LINE__);
        }
        $this->reference_date = $reference_date;
        return $this;
    }
    /**
     * Get legal_entity value
     * @return \StructType\DutchBusinessLegalEntityV3|null
     */
    public function getLegal_entity()
    {
        return $this->legal_entity;
    }
    /**
     * Set legal_entity value
     * @param \StructType\DutchBusinessLegalEntityV3 $legal_entity
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setLegal_entity(\StructType\DutchBusinessLegalEntityV3 $legal_entity = null)
    {
        $this->legal_entity = $legal_entity;
        return $this;
    }
    /**
     * Get partnership value
     * @return \StructType\DutchBusinessPartnershipV3|null
     */
    public function getPartnership()
    {
        return $this->partnership;
    }
    /**
     * Set partnership value
     * @param \StructType\DutchBusinessPartnershipV3 $partnership
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setPartnership(\StructType\DutchBusinessPartnershipV3 $partnership = null)
    {
        $this->partnership = $partnership;
        return $this;
    }
    /**
     * Get enterprise value
     * @return \StructType\DutchBusinessEnterpriseV3|null
     */
    public function getEnterprise()
    {
        return $this->enterprise;
    }
    /**
     * Set enterprise value
     * @param \StructType\DutchBusinessEnterpriseV3 $enterprise
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setEnterprise(\StructType\DutchBusinessEnterpriseV3 $enterprise = null)
    {
        $this->enterprise = $enterprise;
        return $this;
    }
    /**
     * Get establishments value
     * @return \ArrayType\DutchBusinessEstablishmentV3Array|null
     */
    public function getEstablishments()
    {
        return $this->establishments;
    }
    /**
     * Set establishments value
     * @param \ArrayType\DutchBusinessEstablishmentV3Array $establishments
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setEstablishments(\ArrayType\DutchBusinessEstablishmentV3Array $establishments = null)
    {
        $this->establishments = $establishments;
        return $this;
    }
    /**
     * Get positions value
     * @return \ArrayType\DutchBusinessPositionV3Array|null
     */
    public function getPositions()
    {
        return $this->positions;
    }
    /**
     * Set positions value
     * @param \ArrayType\DutchBusinessPositionV3Array $positions
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setPositions(\ArrayType\DutchBusinessPositionV3Array $positions = null)
    {
        $this->positions = $positions;
        return $this;
    }
    /**
     * Get remarks value
     * @return \ArrayType\StringArray|null
     */
    public function getRemarks()
    {
        return $this->remarks;
    }
    /**
     * Set remarks value
     * @param \ArrayType\StringArray $remarks
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public function setRemarks(\ArrayType\StringArray $remarks = null)
    {
        $this->remarks = $remarks;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessExtractDataV3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
