<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessGetConcernRelationsDetailsResult StructType
 * @subpackage Structs
 */
class DutchBusinessGetConcernRelationsDetailsResult extends AbstractStructBase
{
    /**
     * The dossier_number
     * @var string
     */
    public $dossier_number;
    /**
     * The graph
     * @var \StructType\DutchBusinessGetConcernRelationsDetailsGraph
     */
    public $graph;
    /**
     * The pdf
     * @var string
     */
    public $pdf;
    /**
     * The source
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $source;
    /**
     * Constructor method for DutchBusinessGetConcernRelationsDetailsResult
     * @uses DutchBusinessGetConcernRelationsDetailsResult::setDossier_number()
     * @uses DutchBusinessGetConcernRelationsDetailsResult::setGraph()
     * @uses DutchBusinessGetConcernRelationsDetailsResult::setPdf()
     * @uses DutchBusinessGetConcernRelationsDetailsResult::setSource()
     * @param string $dossier_number
     * @param \StructType\DutchBusinessGetConcernRelationsDetailsGraph $graph
     * @param string $pdf
     * @param string $source
     */
    public function __construct($dossier_number = null, \StructType\DutchBusinessGetConcernRelationsDetailsGraph $graph = null, $pdf = null, $source = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setGraph($graph)
            ->setPdf($pdf)
            ->setSource($source);
    }
    /**
     * Get dossier_number value
     * @return string|null
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessGetConcernRelationsDetailsResult
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get graph value
     * @return \StructType\DutchBusinessGetConcernRelationsDetailsGraph|null
     */
    public function getGraph()
    {
        return $this->graph;
    }
    /**
     * Set graph value
     * @param \StructType\DutchBusinessGetConcernRelationsDetailsGraph $graph
     * @return \StructType\DutchBusinessGetConcernRelationsDetailsResult
     */
    public function setGraph(\StructType\DutchBusinessGetConcernRelationsDetailsGraph $graph = null)
    {
        $this->graph = $graph;
        return $this;
    }
    /**
     * Get pdf value
     * @return string|null
     */
    public function getPdf()
    {
        return $this->pdf;
    }
    /**
     * Set pdf value
     * @param string $pdf
     * @return \StructType\DutchBusinessGetConcernRelationsDetailsResult
     */
    public function setPdf($pdf = null)
    {
        // validation for constraint: string
        if (!is_null($pdf) && !is_string($pdf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pdf, true), gettype($pdf)), __LINE__);
        }
        $this->pdf = $pdf;
        return $this;
    }
    /**
     * Get source value
     * @return string|null
     */
    public function getSource()
    {
        return $this->source;
    }
    /**
     * Set source value
     * @param string $source
     * @return \StructType\DutchBusinessGetConcernRelationsDetailsResult
     */
    public function setSource($source = null)
    {
        // validation for constraint: string
        if (!is_null($source) && !is_string($source)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($source, true), gettype($source)), __LINE__);
        }
        $this->source = $source;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessGetConcernRelationsDetailsResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
