<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessLeiAddress StructType
 * @subpackage Structs
 */
class DutchBusinessLeiAddress extends AbstractStructBase
{
    /**
     * The street_and_number
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $street_and_number;
    /**
     * The city
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $city;
    /**
     * The country
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $country;
    /**
     * The postal_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postal_code;
    /**
     * The region
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $region;
    /**
     * Constructor method for DutchBusinessLeiAddress
     * @uses DutchBusinessLeiAddress::setStreet_and_number()
     * @uses DutchBusinessLeiAddress::setCity()
     * @uses DutchBusinessLeiAddress::setCountry()
     * @uses DutchBusinessLeiAddress::setPostal_code()
     * @uses DutchBusinessLeiAddress::setRegion()
     * @param string $street_and_number
     * @param string $city
     * @param string $country
     * @param string $postal_code
     * @param string $region
     */
    public function __construct($street_and_number = null, $city = null, $country = null, $postal_code = null, $region = null)
    {
        $this
            ->setStreet_and_number($street_and_number)
            ->setCity($city)
            ->setCountry($country)
            ->setPostal_code($postal_code)
            ->setRegion($region);
    }
    /**
     * Get street_and_number value
     * @return string
     */
    public function getStreet_and_number()
    {
        return $this->street_and_number;
    }
    /**
     * Set street_and_number value
     * @param string $street_and_number
     * @return \StructType\DutchBusinessLeiAddress
     */
    public function setStreet_and_number($street_and_number = null)
    {
        // validation for constraint: string
        if (!is_null($street_and_number) && !is_string($street_and_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($street_and_number, true), gettype($street_and_number)), __LINE__);
        }
        $this->street_and_number = $street_and_number;
        return $this;
    }
    /**
     * Get city value
     * @return string
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\DutchBusinessLeiAddress
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get country value
     * @return string
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \StructType\DutchBusinessLeiAddress
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get postal_code value
     * @return string|null
     */
    public function getPostal_code()
    {
        return $this->postal_code;
    }
    /**
     * Set postal_code value
     * @param string $postal_code
     * @return \StructType\DutchBusinessLeiAddress
     */
    public function setPostal_code($postal_code = null)
    {
        // validation for constraint: string
        if (!is_null($postal_code) && !is_string($postal_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postal_code, true), gettype($postal_code)), __LINE__);
        }
        $this->postal_code = $postal_code;
        return $this;
    }
    /**
     * Get region value
     * @return string|null
     */
    public function getRegion()
    {
        return $this->region;
    }
    /**
     * Set region value
     * @param string $region
     * @return \StructType\DutchBusinessLeiAddress
     */
    public function setRegion($region = null)
    {
        // validation for constraint: string
        if (!is_null($region) && !is_string($region)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($region, true), gettype($region)), __LINE__);
        }
        $this->region = $region;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessLeiAddress
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
