<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessUBOInvestigationResult StructType
 * @subpackage Structs
 */
class DutchBusinessUBOInvestigationResult extends AbstractStructBase
{
    /**
     * The persons
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \ArrayType\DutchBusinessUBOPersonArray
     */
    public $persons;
    /**
     * The organisations
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \ArrayType\DutchBusinessUBOOrganisationArray
     */
    public $organisations;
    /**
     * The tree
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\DutchBusinessUBOOrganizationNode
     */
    public $tree;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The dossier_number
     * @var string
     */
    public $dossier_number;
    /**
     * Constructor method for DutchBusinessUBOInvestigationResult
     * @uses DutchBusinessUBOInvestigationResult::setPersons()
     * @uses DutchBusinessUBOInvestigationResult::setOrganisations()
     * @uses DutchBusinessUBOInvestigationResult::setTree()
     * @uses DutchBusinessUBOInvestigationResult::setName()
     * @uses DutchBusinessUBOInvestigationResult::setDossier_number()
     * @param \ArrayType\DutchBusinessUBOPersonArray $persons
     * @param \ArrayType\DutchBusinessUBOOrganisationArray $organisations
     * @param \StructType\DutchBusinessUBOOrganizationNode $tree
     * @param string $name
     * @param string $dossier_number
     */
    public function __construct(\ArrayType\DutchBusinessUBOPersonArray $persons = null, \ArrayType\DutchBusinessUBOOrganisationArray $organisations = null, \StructType\DutchBusinessUBOOrganizationNode $tree = null, $name = null, $dossier_number = null)
    {
        $this
            ->setPersons($persons)
            ->setOrganisations($organisations)
            ->setTree($tree)
            ->setName($name)
            ->setDossier_number($dossier_number);
    }
    /**
     * Get persons value
     * @return \ArrayType\DutchBusinessUBOPersonArray
     */
    public function getPersons()
    {
        return $this->persons;
    }
    /**
     * Set persons value
     * @param \ArrayType\DutchBusinessUBOPersonArray $persons
     * @return \StructType\DutchBusinessUBOInvestigationResult
     */
    public function setPersons(\ArrayType\DutchBusinessUBOPersonArray $persons = null)
    {
        $this->persons = $persons;
        return $this;
    }
    /**
     * Get organisations value
     * @return \ArrayType\DutchBusinessUBOOrganisationArray
     */
    public function getOrganisations()
    {
        return $this->organisations;
    }
    /**
     * Set organisations value
     * @param \ArrayType\DutchBusinessUBOOrganisationArray $organisations
     * @return \StructType\DutchBusinessUBOInvestigationResult
     */
    public function setOrganisations(\ArrayType\DutchBusinessUBOOrganisationArray $organisations = null)
    {
        $this->organisations = $organisations;
        return $this;
    }
    /**
     * Get tree value
     * @return \StructType\DutchBusinessUBOOrganizationNode
     */
    public function getTree()
    {
        return $this->tree;
    }
    /**
     * Set tree value
     * @param \StructType\DutchBusinessUBOOrganizationNode $tree
     * @return \StructType\DutchBusinessUBOInvestigationResult
     */
    public function setTree(\StructType\DutchBusinessUBOOrganizationNode $tree = null)
    {
        $this->tree = $tree;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\DutchBusinessUBOInvestigationResult
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get dossier_number value
     * @return string|null
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessUBOInvestigationResult
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessUBOInvestigationResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
