<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessUBOPayment StructType
 * @subpackage Structs
 */
class DutchBusinessUBOPayment extends AbstractStructBase
{
    /**
     * The pre
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $pre;
    /**
     * The cost
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $cost;
    /**
     * The refund
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $refund;
    /**
     * Constructor method for DutchBusinessUBOPayment
     * @uses DutchBusinessUBOPayment::setPre()
     * @uses DutchBusinessUBOPayment::setCost()
     * @uses DutchBusinessUBOPayment::setRefund()
     * @param string $pre
     * @param string $cost
     * @param string $refund
     */
    public function __construct($pre = null, $cost = null, $refund = null)
    {
        $this
            ->setPre($pre)
            ->setCost($cost)
            ->setRefund($refund);
    }
    /**
     * Get pre value
     * @return string
     */
    public function getPre()
    {
        return $this->pre;
    }
    /**
     * Set pre value
     * @param string $pre
     * @return \StructType\DutchBusinessUBOPayment
     */
    public function setPre($pre = null)
    {
        // validation for constraint: string
        if (!is_null($pre) && !is_string($pre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pre, true), gettype($pre)), __LINE__);
        }
        $this->pre = $pre;
        return $this;
    }
    /**
     * Get cost value
     * @return string
     */
    public function getCost()
    {
        return $this->cost;
    }
    /**
     * Set cost value
     * @param string $cost
     * @return \StructType\DutchBusinessUBOPayment
     */
    public function setCost($cost = null)
    {
        // validation for constraint: string
        if (!is_null($cost) && !is_string($cost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cost, true), gettype($cost)), __LINE__);
        }
        $this->cost = $cost;
        return $this;
    }
    /**
     * Get refund value
     * @return string
     */
    public function getRefund()
    {
        return $this->refund;
    }
    /**
     * Set refund value
     * @param string $refund
     * @return \StructType\DutchBusinessUBOPayment
     */
    public function setRefund($refund = null)
    {
        // validation for constraint: string
        if (!is_null($refund) && !is_string($refund)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refund, true), gettype($refund)), __LINE__);
        }
        $this->refund = $refund;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessUBOPayment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
