<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchVehicle StructType
 * @subpackage Structs
 */
class DutchVehicle extends AbstractStructBase
{
    /**
     * The basic_data
     * @var \StructType\DutchVehicleData
     */
    public $basic_data;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleStatus
     */
    public $status;
    /**
     * The registration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleRegistration
     */
    public $registration;
    /**
     * The details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleFeature
     */
    public $details;
    /**
     * The tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleTaxData
     */
    public $tax;
    /**
     * The technical_weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleTechnicalWeight
     */
    public $technical_weight;
    /**
     * The engine
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleEngine
     */
    public $engine;
    /**
     * The environmental_impact
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchVehicleEnvironmentArray
     */
    public $environmental_impact;
    /**
     * The axle_information
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchVehicleAxleArray
     */
    public $axle_information;
    /**
     * The type_approval
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleTypeApproval
     */
    public $type_approval;
    /**
     * The body_approval
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchVehicleBodyApprovalArray
     */
    public $body_approval;
    /**
     * The remark
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchVehicleRemarkArray
     */
    public $remark;
    /**
     * The recall
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchVehicleRecall
     */
    public $recall;
    /**
     * Constructor method for DutchVehicle
     * @uses DutchVehicle::setBasic_data()
     * @uses DutchVehicle::setStatus()
     * @uses DutchVehicle::setRegistration()
     * @uses DutchVehicle::setDetails()
     * @uses DutchVehicle::setTax()
     * @uses DutchVehicle::setTechnical_weight()
     * @uses DutchVehicle::setEngine()
     * @uses DutchVehicle::setEnvironmental_impact()
     * @uses DutchVehicle::setAxle_information()
     * @uses DutchVehicle::setType_approval()
     * @uses DutchVehicle::setBody_approval()
     * @uses DutchVehicle::setRemark()
     * @uses DutchVehicle::setRecall()
     * @param \StructType\DutchVehicleData $basic_data
     * @param \StructType\DutchVehicleStatus $status
     * @param \StructType\DutchVehicleRegistration $registration
     * @param \StructType\DutchVehicleFeature $details
     * @param \StructType\DutchVehicleTaxData $tax
     * @param \StructType\DutchVehicleTechnicalWeight $technical_weight
     * @param \StructType\DutchVehicleEngine $engine
     * @param \ArrayType\DutchVehicleEnvironmentArray $environmental_impact
     * @param \ArrayType\DutchVehicleAxleArray $axle_information
     * @param \StructType\DutchVehicleTypeApproval $type_approval
     * @param \ArrayType\DutchVehicleBodyApprovalArray $body_approval
     * @param \ArrayType\DutchVehicleRemarkArray $remark
     * @param \StructType\DutchVehicleRecall $recall
     */
    public function __construct(\StructType\DutchVehicleData $basic_data = null, \StructType\DutchVehicleStatus $status = null, \StructType\DutchVehicleRegistration $registration = null, \StructType\DutchVehicleFeature $details = null, \StructType\DutchVehicleTaxData $tax = null, \StructType\DutchVehicleTechnicalWeight $technical_weight = null, \StructType\DutchVehicleEngine $engine = null, \ArrayType\DutchVehicleEnvironmentArray $environmental_impact = null, \ArrayType\DutchVehicleAxleArray $axle_information = null, \StructType\DutchVehicleTypeApproval $type_approval = null, \ArrayType\DutchVehicleBodyApprovalArray $body_approval = null, \ArrayType\DutchVehicleRemarkArray $remark = null, \StructType\DutchVehicleRecall $recall = null)
    {
        $this
            ->setBasic_data($basic_data)
            ->setStatus($status)
            ->setRegistration($registration)
            ->setDetails($details)
            ->setTax($tax)
            ->setTechnical_weight($technical_weight)
            ->setEngine($engine)
            ->setEnvironmental_impact($environmental_impact)
            ->setAxle_information($axle_information)
            ->setType_approval($type_approval)
            ->setBody_approval($body_approval)
            ->setRemark($remark)
            ->setRecall($recall);
    }
    /**
     * Get basic_data value
     * @return \StructType\DutchVehicleData|null
     */
    public function getBasic_data()
    {
        return $this->basic_data;
    }
    /**
     * Set basic_data value
     * @param \StructType\DutchVehicleData $basic_data
     * @return \StructType\DutchVehicle
     */
    public function setBasic_data(\StructType\DutchVehicleData $basic_data = null)
    {
        $this->basic_data = $basic_data;
        return $this;
    }
    /**
     * Get status value
     * @return \StructType\DutchVehicleStatus|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \StructType\DutchVehicleStatus $status
     * @return \StructType\DutchVehicle
     */
    public function setStatus(\StructType\DutchVehicleStatus $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Get registration value
     * @return \StructType\DutchVehicleRegistration|null
     */
    public function getRegistration()
    {
        return $this->registration;
    }
    /**
     * Set registration value
     * @param \StructType\DutchVehicleRegistration $registration
     * @return \StructType\DutchVehicle
     */
    public function setRegistration(\StructType\DutchVehicleRegistration $registration = null)
    {
        $this->registration = $registration;
        return $this;
    }
    /**
     * Get details value
     * @return \StructType\DutchVehicleFeature|null
     */
    public function getDetails()
    {
        return $this->details;
    }
    /**
     * Set details value
     * @param \StructType\DutchVehicleFeature $details
     * @return \StructType\DutchVehicle
     */
    public function setDetails(\StructType\DutchVehicleFeature $details = null)
    {
        $this->details = $details;
        return $this;
    }
    /**
     * Get tax value
     * @return \StructType\DutchVehicleTaxData|null
     */
    public function getTax()
    {
        return $this->tax;
    }
    /**
     * Set tax value
     * @param \StructType\DutchVehicleTaxData $tax
     * @return \StructType\DutchVehicle
     */
    public function setTax(\StructType\DutchVehicleTaxData $tax = null)
    {
        $this->tax = $tax;
        return $this;
    }
    /**
     * Get technical_weight value
     * @return \StructType\DutchVehicleTechnicalWeight|null
     */
    public function getTechnical_weight()
    {
        return $this->technical_weight;
    }
    /**
     * Set technical_weight value
     * @param \StructType\DutchVehicleTechnicalWeight $technical_weight
     * @return \StructType\DutchVehicle
     */
    public function setTechnical_weight(\StructType\DutchVehicleTechnicalWeight $technical_weight = null)
    {
        $this->technical_weight = $technical_weight;
        return $this;
    }
    /**
     * Get engine value
     * @return \StructType\DutchVehicleEngine|null
     */
    public function getEngine()
    {
        return $this->engine;
    }
    /**
     * Set engine value
     * @param \StructType\DutchVehicleEngine $engine
     * @return \StructType\DutchVehicle
     */
    public function setEngine(\StructType\DutchVehicleEngine $engine = null)
    {
        $this->engine = $engine;
        return $this;
    }
    /**
     * Get environmental_impact value
     * @return \ArrayType\DutchVehicleEnvironmentArray|null
     */
    public function getEnvironmental_impact()
    {
        return $this->environmental_impact;
    }
    /**
     * Set environmental_impact value
     * @param \ArrayType\DutchVehicleEnvironmentArray $environmental_impact
     * @return \StructType\DutchVehicle
     */
    public function setEnvironmental_impact(\ArrayType\DutchVehicleEnvironmentArray $environmental_impact = null)
    {
        $this->environmental_impact = $environmental_impact;
        return $this;
    }
    /**
     * Get axle_information value
     * @return \ArrayType\DutchVehicleAxleArray|null
     */
    public function getAxle_information()
    {
        return $this->axle_information;
    }
    /**
     * Set axle_information value
     * @param \ArrayType\DutchVehicleAxleArray $axle_information
     * @return \StructType\DutchVehicle
     */
    public function setAxle_information(\ArrayType\DutchVehicleAxleArray $axle_information = null)
    {
        $this->axle_information = $axle_information;
        return $this;
    }
    /**
     * Get type_approval value
     * @return \StructType\DutchVehicleTypeApproval|null
     */
    public function getType_approval()
    {
        return $this->type_approval;
    }
    /**
     * Set type_approval value
     * @param \StructType\DutchVehicleTypeApproval $type_approval
     * @return \StructType\DutchVehicle
     */
    public function setType_approval(\StructType\DutchVehicleTypeApproval $type_approval = null)
    {
        $this->type_approval = $type_approval;
        return $this;
    }
    /**
     * Get body_approval value
     * @return \ArrayType\DutchVehicleBodyApprovalArray|null
     */
    public function getBody_approval()
    {
        return $this->body_approval;
    }
    /**
     * Set body_approval value
     * @param \ArrayType\DutchVehicleBodyApprovalArray $body_approval
     * @return \StructType\DutchVehicle
     */
    public function setBody_approval(\ArrayType\DutchVehicleBodyApprovalArray $body_approval = null)
    {
        $this->body_approval = $body_approval;
        return $this;
    }
    /**
     * Get remark value
     * @return \ArrayType\DutchVehicleRemarkArray|null
     */
    public function getRemark()
    {
        return $this->remark;
    }
    /**
     * Set remark value
     * @param \ArrayType\DutchVehicleRemarkArray $remark
     * @return \StructType\DutchVehicle
     */
    public function setRemark(\ArrayType\DutchVehicleRemarkArray $remark = null)
    {
        $this->remark = $remark;
        return $this;
    }
    /**
     * Get recall value
     * @return \StructType\DutchVehicleRecall|null
     */
    public function getRecall()
    {
        return $this->recall;
    }
    /**
     * Set recall value
     * @param \StructType\DutchVehicleRecall $recall
     * @return \StructType\DutchVehicle
     */
    public function setRecall(\StructType\DutchVehicleRecall $recall = null)
    {
        $this->recall = $recall;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchVehicle
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
