<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRAssets StructType
 * @subpackage Structs
 */
class GCRAssets extends AbstractStructBase
{
    /**
     * The fixed_assets_total
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRItem
     */
    public $fixed_assets_total;
    /**
     * The fixed_assets_items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRItemArray
     */
    public $fixed_assets_items;
    /**
     * The current_assets_total
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRItem
     */
    public $current_assets_total;
    /**
     * The current_assets_items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRItemArray
     */
    public $current_assets_items;
    /**
     * The balance_sheet_total
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $balance_sheet_total;
    /**
     * Constructor method for GCRAssets
     * @uses GCRAssets::setFixed_assets_total()
     * @uses GCRAssets::setFixed_assets_items()
     * @uses GCRAssets::setCurrent_assets_total()
     * @uses GCRAssets::setCurrent_assets_items()
     * @uses GCRAssets::setBalance_sheet_total()
     * @param \StructType\GCRItem $fixed_assets_total
     * @param \ArrayType\GCRItemArray $fixed_assets_items
     * @param \StructType\GCRItem $current_assets_total
     * @param \ArrayType\GCRItemArray $current_assets_items
     * @param float $balance_sheet_total
     */
    public function __construct(\StructType\GCRItem $fixed_assets_total = null, \ArrayType\GCRItemArray $fixed_assets_items = null, \StructType\GCRItem $current_assets_total = null, \ArrayType\GCRItemArray $current_assets_items = null, $balance_sheet_total = null)
    {
        $this
            ->setFixed_assets_total($fixed_assets_total)
            ->setFixed_assets_items($fixed_assets_items)
            ->setCurrent_assets_total($current_assets_total)
            ->setCurrent_assets_items($current_assets_items)
            ->setBalance_sheet_total($balance_sheet_total);
    }
    /**
     * Get fixed_assets_total value
     * @return \StructType\GCRItem|null
     */
    public function getFixed_assets_total()
    {
        return $this->fixed_assets_total;
    }
    /**
     * Set fixed_assets_total value
     * @param \StructType\GCRItem $fixed_assets_total
     * @return \StructType\GCRAssets
     */
    public function setFixed_assets_total(\StructType\GCRItem $fixed_assets_total = null)
    {
        $this->fixed_assets_total = $fixed_assets_total;
        return $this;
    }
    /**
     * Get fixed_assets_items value
     * @return \ArrayType\GCRItemArray|null
     */
    public function getFixed_assets_items()
    {
        return $this->fixed_assets_items;
    }
    /**
     * Set fixed_assets_items value
     * @param \ArrayType\GCRItemArray $fixed_assets_items
     * @return \StructType\GCRAssets
     */
    public function setFixed_assets_items(\ArrayType\GCRItemArray $fixed_assets_items = null)
    {
        $this->fixed_assets_items = $fixed_assets_items;
        return $this;
    }
    /**
     * Get current_assets_total value
     * @return \StructType\GCRItem|null
     */
    public function getCurrent_assets_total()
    {
        return $this->current_assets_total;
    }
    /**
     * Set current_assets_total value
     * @param \StructType\GCRItem $current_assets_total
     * @return \StructType\GCRAssets
     */
    public function setCurrent_assets_total(\StructType\GCRItem $current_assets_total = null)
    {
        $this->current_assets_total = $current_assets_total;
        return $this;
    }
    /**
     * Get current_assets_items value
     * @return \ArrayType\GCRItemArray|null
     */
    public function getCurrent_assets_items()
    {
        return $this->current_assets_items;
    }
    /**
     * Set current_assets_items value
     * @param \ArrayType\GCRItemArray $current_assets_items
     * @return \StructType\GCRAssets
     */
    public function setCurrent_assets_items(\ArrayType\GCRItemArray $current_assets_items = null)
    {
        $this->current_assets_items = $current_assets_items;
        return $this;
    }
    /**
     * Get balance_sheet_total value
     * @return float|null
     */
    public function getBalance_sheet_total()
    {
        return $this->balance_sheet_total;
    }
    /**
     * Set balance_sheet_total value
     * @param float $balance_sheet_total
     * @return \StructType\GCRAssets
     */
    public function setBalance_sheet_total($balance_sheet_total = null)
    {
        // validation for constraint: float
        if (!is_null($balance_sheet_total) && !(is_float($balance_sheet_total) || is_numeric($balance_sheet_total))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($balance_sheet_total, true), gettype($balance_sheet_total)), __LINE__);
        }
        $this->balance_sheet_total = $balance_sheet_total;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GCRAssets
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
