<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRBalanceSheet StructType
 * @subpackage Structs
 */
class GCRBalanceSheet extends AbstractStructBase
{
    /**
     * The items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRItemArray
     */
    public $items;
    /**
     * The assets
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRAssets
     */
    public $assets;
    /**
     * The liabilities
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRLiabilities
     */
    public $liabilities;
    /**
     * Constructor method for GCRBalanceSheet
     * @uses GCRBalanceSheet::setItems()
     * @uses GCRBalanceSheet::setAssets()
     * @uses GCRBalanceSheet::setLiabilities()
     * @param \ArrayType\GCRItemArray $items
     * @param \StructType\GCRAssets $assets
     * @param \StructType\GCRLiabilities $liabilities
     */
    public function __construct(\ArrayType\GCRItemArray $items = null, \StructType\GCRAssets $assets = null, \StructType\GCRLiabilities $liabilities = null)
    {
        $this
            ->setItems($items)
            ->setAssets($assets)
            ->setLiabilities($liabilities);
    }
    /**
     * Get items value
     * @return \ArrayType\GCRItemArray|null
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param \ArrayType\GCRItemArray $items
     * @return \StructType\GCRBalanceSheet
     */
    public function setItems(\ArrayType\GCRItemArray $items = null)
    {
        $this->items = $items;
        return $this;
    }
    /**
     * Get assets value
     * @return \StructType\GCRAssets|null
     */
    public function getAssets()
    {
        return $this->assets;
    }
    /**
     * Set assets value
     * @param \StructType\GCRAssets $assets
     * @return \StructType\GCRBalanceSheet
     */
    public function setAssets(\StructType\GCRAssets $assets = null)
    {
        $this->assets = $assets;
        return $this;
    }
    /**
     * Get liabilities value
     * @return \StructType\GCRLiabilities|null
     */
    public function getLiabilities()
    {
        return $this->liabilities;
    }
    /**
     * Set liabilities value
     * @param \StructType\GCRLiabilities $liabilities
     * @return \StructType\GCRBalanceSheet
     */
    public function setLiabilities(\StructType\GCRLiabilities $liabilities = null)
    {
        $this->liabilities = $liabilities;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GCRBalanceSheet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
