<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRLiaisonContactDetails StructType
 * @subpackage Structs
 */
class GCRLiaisonContactDetails extends AbstractStructBase
{
    /**
     * The company_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $company_name;
    /**
     * The addresses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRAddressArray
     */
    public $addresses;
    /**
     * The telephone_numbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRTelephoneNumberArray
     */
    public $telephone_numbers;
    /**
     * Constructor method for GCRLiaisonContactDetails
     * @uses GCRLiaisonContactDetails::setCompany_name()
     * @uses GCRLiaisonContactDetails::setAddresses()
     * @uses GCRLiaisonContactDetails::setTelephone_numbers()
     * @param string $company_name
     * @param \ArrayType\GCRAddressArray $addresses
     * @param \ArrayType\GCRTelephoneNumberArray $telephone_numbers
     */
    public function __construct($company_name = null, \ArrayType\GCRAddressArray $addresses = null, \ArrayType\GCRTelephoneNumberArray $telephone_numbers = null)
    {
        $this
            ->setCompany_name($company_name)
            ->setAddresses($addresses)
            ->setTelephone_numbers($telephone_numbers);
    }
    /**
     * Get company_name value
     * @return string|null
     */
    public function getCompany_name()
    {
        return $this->company_name;
    }
    /**
     * Set company_name value
     * @param string $company_name
     * @return \StructType\GCRLiaisonContactDetails
     */
    public function setCompany_name($company_name = null)
    {
        // validation for constraint: string
        if (!is_null($company_name) && !is_string($company_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_name, true), gettype($company_name)), __LINE__);
        }
        $this->company_name = $company_name;
        return $this;
    }
    /**
     * Get addresses value
     * @return \ArrayType\GCRAddressArray|null
     */
    public function getAddresses()
    {
        return $this->addresses;
    }
    /**
     * Set addresses value
     * @param \ArrayType\GCRAddressArray $addresses
     * @return \StructType\GCRLiaisonContactDetails
     */
    public function setAddresses(\ArrayType\GCRAddressArray $addresses = null)
    {
        $this->addresses = $addresses;
        return $this;
    }
    /**
     * Get telephone_numbers value
     * @return \ArrayType\GCRTelephoneNumberArray|null
     */
    public function getTelephone_numbers()
    {
        return $this->telephone_numbers;
    }
    /**
     * Set telephone_numbers value
     * @param \ArrayType\GCRTelephoneNumberArray $telephone_numbers
     * @return \StructType\GCRLiaisonContactDetails
     */
    public function setTelephone_numbers(\ArrayType\GCRTelephoneNumberArray $telephone_numbers = null)
    {
        $this->telephone_numbers = $telephone_numbers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GCRLiaisonContactDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
