<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for geoLocationHaversineDistanceResponseType StructType
 * @subpackage Structs
 */
class GeoLocationHaversineDistanceResponseType extends AbstractStructBase
{
    /**
     * The distance
     * @var int
     */
    public $distance;
    /**
     * Constructor method for geoLocationHaversineDistanceResponseType
     * @uses GeoLocationHaversineDistanceResponseType::setDistance()
     * @param int $distance
     */
    public function __construct($distance = null)
    {
        $this
            ->setDistance($distance);
    }
    /**
     * Get distance value
     * @return int|null
     */
    public function getDistance()
    {
        return $this->distance;
    }
    /**
     * Set distance value
     * @param int $distance
     * @return \StructType\GeoLocationHaversineDistanceResponseType
     */
    public function setDistance($distance = null)
    {
        // validation for constraint: int
        if (!is_null($distance) && !(is_int($distance) || ctype_digit($distance))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($distance, true), gettype($distance)), __LINE__);
        }
        $this->distance = $distance;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeoLocationHaversineDistanceResponseType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
