<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Aantekening StructType
 * @subpackage Structs
 */
class KadasterV2Aantekening extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $identificatie;
    /**
     * The aard
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $aard;
    /**
     * The omschrijving
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $omschrijving;
    /**
     * The einddatum
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $einddatum;
    /**
     * The einddatum_recht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $einddatum_recht;
    /**
     * The herkaveling_bloknummer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $herkaveling_bloknummer;
    /**
     * The betreft
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2OnroerendeZaak
     */
    public $betreft;
    /**
     * The hypotheken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2HypotheekArray
     */
    public $hypotheken;
    /**
     * The beslagleggingen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2BeslagleggingArray
     */
    public $beslagleggingen;
    /**
     * The vermeld_in
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $vermeld_in;
    /**
     * The tenaamstellingen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2TenaamstellingArray
     */
    public $tenaamstellingen;
    /**
     * The gebaseerd_op
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Stukdeel
     */
    public $gebaseerd_op;
    /**
     * The betrokken_personen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Personen
     */
    public $betrokken_personen;
    /**
     * Constructor method for KadasterV2Aantekening
     * @uses KadasterV2Aantekening::setIdentificatie()
     * @uses KadasterV2Aantekening::setAard()
     * @uses KadasterV2Aantekening::setOmschrijving()
     * @uses KadasterV2Aantekening::setEinddatum()
     * @uses KadasterV2Aantekening::setEinddatum_recht()
     * @uses KadasterV2Aantekening::setHerkaveling_bloknummer()
     * @uses KadasterV2Aantekening::setBetreft()
     * @uses KadasterV2Aantekening::setHypotheken()
     * @uses KadasterV2Aantekening::setBeslagleggingen()
     * @uses KadasterV2Aantekening::setVermeld_in()
     * @uses KadasterV2Aantekening::setTenaamstellingen()
     * @uses KadasterV2Aantekening::setGebaseerd_op()
     * @uses KadasterV2Aantekening::setBetrokken_personen()
     * @param string $identificatie
     * @param string $aard
     * @param string $omschrijving
     * @param string $einddatum
     * @param string $einddatum_recht
     * @param int $herkaveling_bloknummer
     * @param \StructType\KadasterV2OnroerendeZaak $betreft
     * @param \ArrayType\KadasterV2HypotheekArray $hypotheken
     * @param \ArrayType\KadasterV2BeslagleggingArray $beslagleggingen
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @param \ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen
     * @param \StructType\KadasterV2Stukdeel $gebaseerd_op
     * @param \StructType\KadasterV2Personen $betrokken_personen
     */
    public function __construct($identificatie = null, $aard = null, $omschrijving = null, $einddatum = null, $einddatum_recht = null, $herkaveling_bloknummer = null, \StructType\KadasterV2OnroerendeZaak $betreft = null, \ArrayType\KadasterV2HypotheekArray $hypotheken = null, \ArrayType\KadasterV2BeslagleggingArray $beslagleggingen = null, \ArrayType\KadasterV2StukdeelArray $vermeld_in = null, \ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen = null, \StructType\KadasterV2Stukdeel $gebaseerd_op = null, \StructType\KadasterV2Personen $betrokken_personen = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setAard($aard)
            ->setOmschrijving($omschrijving)
            ->setEinddatum($einddatum)
            ->setEinddatum_recht($einddatum_recht)
            ->setHerkaveling_bloknummer($herkaveling_bloknummer)
            ->setBetreft($betreft)
            ->setHypotheken($hypotheken)
            ->setBeslagleggingen($beslagleggingen)
            ->setVermeld_in($vermeld_in)
            ->setTenaamstellingen($tenaamstellingen)
            ->setGebaseerd_op($gebaseerd_op)
            ->setBetrokken_personen($betrokken_personen);
    }
    /**
     * Get identificatie value
     * @return string
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Aantekening
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get aard value
     * @return string|null
     */
    public function getAard()
    {
        return $this->aard;
    }
    /**
     * Set aard value
     * @param string $aard
     * @return \StructType\KadasterV2Aantekening
     */
    public function setAard($aard = null)
    {
        // validation for constraint: string
        if (!is_null($aard) && !is_string($aard)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aard, true), gettype($aard)), __LINE__);
        }
        $this->aard = $aard;
        return $this;
    }
    /**
     * Get omschrijving value
     * @return string|null
     */
    public function getOmschrijving()
    {
        return $this->omschrijving;
    }
    /**
     * Set omschrijving value
     * @param string $omschrijving
     * @return \StructType\KadasterV2Aantekening
     */
    public function setOmschrijving($omschrijving = null)
    {
        // validation for constraint: string
        if (!is_null($omschrijving) && !is_string($omschrijving)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($omschrijving, true), gettype($omschrijving)), __LINE__);
        }
        $this->omschrijving = $omschrijving;
        return $this;
    }
    /**
     * Get einddatum value
     * @return string|null
     */
    public function getEinddatum()
    {
        return $this->einddatum;
    }
    /**
     * Set einddatum value
     * @param string $einddatum
     * @return \StructType\KadasterV2Aantekening
     */
    public function setEinddatum($einddatum = null)
    {
        // validation for constraint: string
        if (!is_null($einddatum) && !is_string($einddatum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($einddatum, true), gettype($einddatum)), __LINE__);
        }
        $this->einddatum = $einddatum;
        return $this;
    }
    /**
     * Get einddatum_recht value
     * @return string|null
     */
    public function getEinddatum_recht()
    {
        return $this->einddatum_recht;
    }
    /**
     * Set einddatum_recht value
     * @param string $einddatum_recht
     * @return \StructType\KadasterV2Aantekening
     */
    public function setEinddatum_recht($einddatum_recht = null)
    {
        // validation for constraint: string
        if (!is_null($einddatum_recht) && !is_string($einddatum_recht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($einddatum_recht, true), gettype($einddatum_recht)), __LINE__);
        }
        $this->einddatum_recht = $einddatum_recht;
        return $this;
    }
    /**
     * Get herkaveling_bloknummer value
     * @return int|null
     */
    public function getHerkaveling_bloknummer()
    {
        return $this->herkaveling_bloknummer;
    }
    /**
     * Set herkaveling_bloknummer value
     * @param int $herkaveling_bloknummer
     * @return \StructType\KadasterV2Aantekening
     */
    public function setHerkaveling_bloknummer($herkaveling_bloknummer = null)
    {
        // validation for constraint: int
        if (!is_null($herkaveling_bloknummer) && !(is_int($herkaveling_bloknummer) || ctype_digit($herkaveling_bloknummer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($herkaveling_bloknummer, true), gettype($herkaveling_bloknummer)), __LINE__);
        }
        $this->herkaveling_bloknummer = $herkaveling_bloknummer;
        return $this;
    }
    /**
     * Get betreft value
     * @return \StructType\KadasterV2OnroerendeZaak|null
     */
    public function getBetreft()
    {
        return $this->betreft;
    }
    /**
     * Set betreft value
     * @param \StructType\KadasterV2OnroerendeZaak $betreft
     * @return \StructType\KadasterV2Aantekening
     */
    public function setBetreft(\StructType\KadasterV2OnroerendeZaak $betreft = null)
    {
        $this->betreft = $betreft;
        return $this;
    }
    /**
     * Get hypotheken value
     * @return \ArrayType\KadasterV2HypotheekArray|null
     */
    public function getHypotheken()
    {
        return $this->hypotheken;
    }
    /**
     * Set hypotheken value
     * @param \ArrayType\KadasterV2HypotheekArray $hypotheken
     * @return \StructType\KadasterV2Aantekening
     */
    public function setHypotheken(\ArrayType\KadasterV2HypotheekArray $hypotheken = null)
    {
        $this->hypotheken = $hypotheken;
        return $this;
    }
    /**
     * Get beslagleggingen value
     * @return \ArrayType\KadasterV2BeslagleggingArray|null
     */
    public function getBeslagleggingen()
    {
        return $this->beslagleggingen;
    }
    /**
     * Set beslagleggingen value
     * @param \ArrayType\KadasterV2BeslagleggingArray $beslagleggingen
     * @return \StructType\KadasterV2Aantekening
     */
    public function setBeslagleggingen(\ArrayType\KadasterV2BeslagleggingArray $beslagleggingen = null)
    {
        $this->beslagleggingen = $beslagleggingen;
        return $this;
    }
    /**
     * Get vermeld_in value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getVermeld_in()
    {
        return $this->vermeld_in;
    }
    /**
     * Set vermeld_in value
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @return \StructType\KadasterV2Aantekening
     */
    public function setVermeld_in(\ArrayType\KadasterV2StukdeelArray $vermeld_in = null)
    {
        $this->vermeld_in = $vermeld_in;
        return $this;
    }
    /**
     * Get tenaamstellingen value
     * @return \ArrayType\KadasterV2TenaamstellingArray|null
     */
    public function getTenaamstellingen()
    {
        return $this->tenaamstellingen;
    }
    /**
     * Set tenaamstellingen value
     * @param \ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen
     * @return \StructType\KadasterV2Aantekening
     */
    public function setTenaamstellingen(\ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen = null)
    {
        $this->tenaamstellingen = $tenaamstellingen;
        return $this;
    }
    /**
     * Get gebaseerd_op value
     * @return \StructType\KadasterV2Stukdeel|null
     */
    public function getGebaseerd_op()
    {
        return $this->gebaseerd_op;
    }
    /**
     * Set gebaseerd_op value
     * @param \StructType\KadasterV2Stukdeel $gebaseerd_op
     * @return \StructType\KadasterV2Aantekening
     */
    public function setGebaseerd_op(\StructType\KadasterV2Stukdeel $gebaseerd_op = null)
    {
        $this->gebaseerd_op = $gebaseerd_op;
        return $this;
    }
    /**
     * Get betrokken_personen value
     * @return \StructType\KadasterV2Personen|null
     */
    public function getBetrokken_personen()
    {
        return $this->betrokken_personen;
    }
    /**
     * Set betrokken_personen value
     * @param \StructType\KadasterV2Personen $betrokken_personen
     * @return \StructType\KadasterV2Aantekening
     */
    public function setBetrokken_personen(\StructType\KadasterV2Personen $betrokken_personen = null)
    {
        $this->betrokken_personen = $betrokken_personen;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2Aantekening
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
