<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2KoopsommenOverzicht StructType
 * @subpackage Structs
 */
class KadasterV2KoopsommenOverzicht extends AbstractStructBase
{
    /**
     * The productienummer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $productienummer;
    /**
     * The adres_range
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $adres_range;
    /**
     * The woonplaats_naam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $woonplaats_naam;
    /**
     * The actualiteittijdstip_koopsommen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $actualiteittijdstip_koopsommen;
    /**
     * The tijdstip_samenstelling_bericht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tijdstip_samenstelling_bericht;
    /**
     * The gevraagd_gebied
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2GevraagdGebied
     */
    public $gevraagd_gebied;
    /**
     * Constructor method for KadasterV2KoopsommenOverzicht
     * @uses KadasterV2KoopsommenOverzicht::setProductienummer()
     * @uses KadasterV2KoopsommenOverzicht::setAdres_range()
     * @uses KadasterV2KoopsommenOverzicht::setWoonplaats_naam()
     * @uses KadasterV2KoopsommenOverzicht::setActualiteittijdstip_koopsommen()
     * @uses KadasterV2KoopsommenOverzicht::setTijdstip_samenstelling_bericht()
     * @uses KadasterV2KoopsommenOverzicht::setGevraagd_gebied()
     * @param string $productienummer
     * @param string $adres_range
     * @param string $woonplaats_naam
     * @param string $actualiteittijdstip_koopsommen
     * @param string $tijdstip_samenstelling_bericht
     * @param \StructType\KadasterV2GevraagdGebied $gevraagd_gebied
     */
    public function __construct($productienummer = null, $adres_range = null, $woonplaats_naam = null, $actualiteittijdstip_koopsommen = null, $tijdstip_samenstelling_bericht = null, \StructType\KadasterV2GevraagdGebied $gevraagd_gebied = null)
    {
        $this
            ->setProductienummer($productienummer)
            ->setAdres_range($adres_range)
            ->setWoonplaats_naam($woonplaats_naam)
            ->setActualiteittijdstip_koopsommen($actualiteittijdstip_koopsommen)
            ->setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht)
            ->setGevraagd_gebied($gevraagd_gebied);
    }
    /**
     * Get productienummer value
     * @return string|null
     */
    public function getProductienummer()
    {
        return $this->productienummer;
    }
    /**
     * Set productienummer value
     * @param string $productienummer
     * @return \StructType\KadasterV2KoopsommenOverzicht
     */
    public function setProductienummer($productienummer = null)
    {
        // validation for constraint: string
        if (!is_null($productienummer) && !is_string($productienummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productienummer, true), gettype($productienummer)), __LINE__);
        }
        $this->productienummer = $productienummer;
        return $this;
    }
    /**
     * Get adres_range value
     * @return string|null
     */
    public function getAdres_range()
    {
        return $this->adres_range;
    }
    /**
     * Set adres_range value
     * @param string $adres_range
     * @return \StructType\KadasterV2KoopsommenOverzicht
     */
    public function setAdres_range($adres_range = null)
    {
        // validation for constraint: string
        if (!is_null($adres_range) && !is_string($adres_range)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adres_range, true), gettype($adres_range)), __LINE__);
        }
        $this->adres_range = $adres_range;
        return $this;
    }
    /**
     * Get woonplaats_naam value
     * @return string|null
     */
    public function getWoonplaats_naam()
    {
        return $this->woonplaats_naam;
    }
    /**
     * Set woonplaats_naam value
     * @param string $woonplaats_naam
     * @return \StructType\KadasterV2KoopsommenOverzicht
     */
    public function setWoonplaats_naam($woonplaats_naam = null)
    {
        // validation for constraint: string
        if (!is_null($woonplaats_naam) && !is_string($woonplaats_naam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($woonplaats_naam, true), gettype($woonplaats_naam)), __LINE__);
        }
        $this->woonplaats_naam = $woonplaats_naam;
        return $this;
    }
    /**
     * Get actualiteittijdstip_koopsommen value
     * @return string|null
     */
    public function getActualiteittijdstip_koopsommen()
    {
        return $this->actualiteittijdstip_koopsommen;
    }
    /**
     * Set actualiteittijdstip_koopsommen value
     * @param string $actualiteittijdstip_koopsommen
     * @return \StructType\KadasterV2KoopsommenOverzicht
     */
    public function setActualiteittijdstip_koopsommen($actualiteittijdstip_koopsommen = null)
    {
        // validation for constraint: string
        if (!is_null($actualiteittijdstip_koopsommen) && !is_string($actualiteittijdstip_koopsommen)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualiteittijdstip_koopsommen, true), gettype($actualiteittijdstip_koopsommen)), __LINE__);
        }
        $this->actualiteittijdstip_koopsommen = $actualiteittijdstip_koopsommen;
        return $this;
    }
    /**
     * Get tijdstip_samenstelling_bericht value
     * @return string|null
     */
    public function getTijdstip_samenstelling_bericht()
    {
        return $this->tijdstip_samenstelling_bericht;
    }
    /**
     * Set tijdstip_samenstelling_bericht value
     * @param string $tijdstip_samenstelling_bericht
     * @return \StructType\KadasterV2KoopsommenOverzicht
     */
    public function setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht = null)
    {
        // validation for constraint: string
        if (!is_null($tijdstip_samenstelling_bericht) && !is_string($tijdstip_samenstelling_bericht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tijdstip_samenstelling_bericht, true), gettype($tijdstip_samenstelling_bericht)), __LINE__);
        }
        $this->tijdstip_samenstelling_bericht = $tijdstip_samenstelling_bericht;
        return $this;
    }
    /**
     * Get gevraagd_gebied value
     * @return \StructType\KadasterV2GevraagdGebied|null
     */
    public function getGevraagd_gebied()
    {
        return $this->gevraagd_gebied;
    }
    /**
     * Set gevraagd_gebied value
     * @param \StructType\KadasterV2GevraagdGebied $gevraagd_gebied
     * @return \StructType\KadasterV2KoopsommenOverzicht
     */
    public function setGevraagd_gebied(\StructType\KadasterV2GevraagdGebied $gevraagd_gebied = null)
    {
        $this->gevraagd_gebied = $gevraagd_gebied;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2KoopsommenOverzicht
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
