<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2LandinrichtingsRente StructType
 * @subpackage Structs
 */
class KadasterV2LandinrichtingsRente extends AbstractStructBase
{
    /**
     * The bedrag
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Bedrag
     */
    public $bedrag;
    /**
     * The eindjaar
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $eindjaar;
    /**
     * Constructor method for KadasterV2LandinrichtingsRente
     * @uses KadasterV2LandinrichtingsRente::setBedrag()
     * @uses KadasterV2LandinrichtingsRente::setEindjaar()
     * @param \StructType\KadasterV2Bedrag $bedrag
     * @param int $eindjaar
     */
    public function __construct(\StructType\KadasterV2Bedrag $bedrag = null, $eindjaar = null)
    {
        $this
            ->setBedrag($bedrag)
            ->setEindjaar($eindjaar);
    }
    /**
     * Get bedrag value
     * @return \StructType\KadasterV2Bedrag|null
     */
    public function getBedrag()
    {
        return $this->bedrag;
    }
    /**
     * Set bedrag value
     * @param \StructType\KadasterV2Bedrag $bedrag
     * @return \StructType\KadasterV2LandinrichtingsRente
     */
    public function setBedrag(\StructType\KadasterV2Bedrag $bedrag = null)
    {
        $this->bedrag = $bedrag;
        return $this;
    }
    /**
     * Get eindjaar value
     * @return int|null
     */
    public function getEindjaar()
    {
        return $this->eindjaar;
    }
    /**
     * Set eindjaar value
     * @param int $eindjaar
     * @return \StructType\KadasterV2LandinrichtingsRente
     */
    public function setEindjaar($eindjaar = null)
    {
        // validation for constraint: int
        if (!is_null($eindjaar) && !(is_int($eindjaar) || ctype_digit($eindjaar))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($eindjaar, true), gettype($eindjaar)), __LINE__);
        }
        $this->eindjaar = $eindjaar;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2LandinrichtingsRente
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
