<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2LocatiePostbus StructType
 * @subpackage Structs
 */
class KadasterV2LocatiePostbus extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $identificatie;
    /**
     * The postbus_nummer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postbus_nummer;
    /**
     * The postcode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postcode;
    /**
     * The woonplaats
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $woonplaats;
    /**
     * Constructor method for KadasterV2LocatiePostbus
     * @uses KadasterV2LocatiePostbus::setIdentificatie()
     * @uses KadasterV2LocatiePostbus::setPostbus_nummer()
     * @uses KadasterV2LocatiePostbus::setPostcode()
     * @uses KadasterV2LocatiePostbus::setWoonplaats()
     * @param string $identificatie
     * @param string $postbus_nummer
     * @param string $postcode
     * @param string $woonplaats
     */
    public function __construct($identificatie = null, $postbus_nummer = null, $postcode = null, $woonplaats = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setPostbus_nummer($postbus_nummer)
            ->setPostcode($postcode)
            ->setWoonplaats($woonplaats);
    }
    /**
     * Get identificatie value
     * @return string
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2LocatiePostbus
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get postbus_nummer value
     * @return string|null
     */
    public function getPostbus_nummer()
    {
        return $this->postbus_nummer;
    }
    /**
     * Set postbus_nummer value
     * @param string $postbus_nummer
     * @return \StructType\KadasterV2LocatiePostbus
     */
    public function setPostbus_nummer($postbus_nummer = null)
    {
        // validation for constraint: string
        if (!is_null($postbus_nummer) && !is_string($postbus_nummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postbus_nummer, true), gettype($postbus_nummer)), __LINE__);
        }
        $this->postbus_nummer = $postbus_nummer;
        return $this;
    }
    /**
     * Get postcode value
     * @return string|null
     */
    public function getPostcode()
    {
        return $this->postcode;
    }
    /**
     * Set postcode value
     * @param string $postcode
     * @return \StructType\KadasterV2LocatiePostbus
     */
    public function setPostcode($postcode = null)
    {
        // validation for constraint: string
        if (!is_null($postcode) && !is_string($postcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postcode, true), gettype($postcode)), __LINE__);
        }
        $this->postcode = $postcode;
        return $this;
    }
    /**
     * Get woonplaats value
     * @return string|null
     */
    public function getWoonplaats()
    {
        return $this->woonplaats;
    }
    /**
     * Set woonplaats value
     * @param string $woonplaats
     * @return \StructType\KadasterV2LocatiePostbus
     */
    public function setWoonplaats($woonplaats = null)
    {
        // validation for constraint: string
        if (!is_null($woonplaats) && !is_string($woonplaats)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($woonplaats, true), gettype($woonplaats)), __LINE__);
        }
        $this->woonplaats = $woonplaats;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2LocatiePostbus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
