<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2NietNatuurlijkPersoon StructType
 * @subpackage Structs
 */
class KadasterV2NietNatuurlijkPersoon extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The indicatie_beschikkingsbevoegdheid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $indicatie_beschikkingsbevoegdheid;
    /**
     * The statutaire_naam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $statutaire_naam;
    /**
     * The statutaire_zetel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $statutaire_zetel;
    /**
     * The rechtsvorm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rechtsvorm;
    /**
     * The dossier_nummer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dossier_nummer;
    /**
     * The rsin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rsin;
    /**
     * The postlocatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2AdresLocatie
     */
    public $postlocatie;
    /**
     * The woonlocatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2AdresLocatie
     */
    public $woonlocatie;
    /**
     * The vermeld_in
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $vermeld_in;
    /**
     * The aanvullingen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2AanvullingArray
     */
    public $aanvullingen;
    /**
     * Constructor method for KadasterV2NietNatuurlijkPersoon
     * @uses KadasterV2NietNatuurlijkPersoon::setIdentificatie()
     * @uses KadasterV2NietNatuurlijkPersoon::setIndicatie_beschikkingsbevoegdheid()
     * @uses KadasterV2NietNatuurlijkPersoon::setStatutaire_naam()
     * @uses KadasterV2NietNatuurlijkPersoon::setStatutaire_zetel()
     * @uses KadasterV2NietNatuurlijkPersoon::setRechtsvorm()
     * @uses KadasterV2NietNatuurlijkPersoon::setDossier_nummer()
     * @uses KadasterV2NietNatuurlijkPersoon::setRsin()
     * @uses KadasterV2NietNatuurlijkPersoon::setPostlocatie()
     * @uses KadasterV2NietNatuurlijkPersoon::setWoonlocatie()
     * @uses KadasterV2NietNatuurlijkPersoon::setVermeld_in()
     * @uses KadasterV2NietNatuurlijkPersoon::setAanvullingen()
     * @param string $identificatie
     * @param bool $indicatie_beschikkingsbevoegdheid
     * @param string $statutaire_naam
     * @param string $statutaire_zetel
     * @param string $rechtsvorm
     * @param string $dossier_nummer
     * @param string $rsin
     * @param \StructType\KadasterV2AdresLocatie $postlocatie
     * @param \StructType\KadasterV2AdresLocatie $woonlocatie
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @param \ArrayType\KadasterV2AanvullingArray $aanvullingen
     */
    public function __construct($identificatie = null, $indicatie_beschikkingsbevoegdheid = null, $statutaire_naam = null, $statutaire_zetel = null, $rechtsvorm = null, $dossier_nummer = null, $rsin = null, \StructType\KadasterV2AdresLocatie $postlocatie = null, \StructType\KadasterV2AdresLocatie $woonlocatie = null, \ArrayType\KadasterV2StukdeelArray $vermeld_in = null, \ArrayType\KadasterV2AanvullingArray $aanvullingen = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setIndicatie_beschikkingsbevoegdheid($indicatie_beschikkingsbevoegdheid)
            ->setStatutaire_naam($statutaire_naam)
            ->setStatutaire_zetel($statutaire_zetel)
            ->setRechtsvorm($rechtsvorm)
            ->setDossier_nummer($dossier_nummer)
            ->setRsin($rsin)
            ->setPostlocatie($postlocatie)
            ->setWoonlocatie($woonlocatie)
            ->setVermeld_in($vermeld_in)
            ->setAanvullingen($aanvullingen);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get indicatie_beschikkingsbevoegdheid value
     * @return bool|null
     */
    public function getIndicatie_beschikkingsbevoegdheid()
    {
        return $this->indicatie_beschikkingsbevoegdheid;
    }
    /**
     * Set indicatie_beschikkingsbevoegdheid value
     * @param bool $indicatie_beschikkingsbevoegdheid
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setIndicatie_beschikkingsbevoegdheid($indicatie_beschikkingsbevoegdheid = null)
    {
        // validation for constraint: boolean
        if (!is_null($indicatie_beschikkingsbevoegdheid) && !is_bool($indicatie_beschikkingsbevoegdheid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($indicatie_beschikkingsbevoegdheid, true), gettype($indicatie_beschikkingsbevoegdheid)), __LINE__);
        }
        $this->indicatie_beschikkingsbevoegdheid = $indicatie_beschikkingsbevoegdheid;
        return $this;
    }
    /**
     * Get statutaire_naam value
     * @return string|null
     */
    public function getStatutaire_naam()
    {
        return $this->statutaire_naam;
    }
    /**
     * Set statutaire_naam value
     * @param string $statutaire_naam
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setStatutaire_naam($statutaire_naam = null)
    {
        // validation for constraint: string
        if (!is_null($statutaire_naam) && !is_string($statutaire_naam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statutaire_naam, true), gettype($statutaire_naam)), __LINE__);
        }
        $this->statutaire_naam = $statutaire_naam;
        return $this;
    }
    /**
     * Get statutaire_zetel value
     * @return string|null
     */
    public function getStatutaire_zetel()
    {
        return $this->statutaire_zetel;
    }
    /**
     * Set statutaire_zetel value
     * @param string $statutaire_zetel
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setStatutaire_zetel($statutaire_zetel = null)
    {
        // validation for constraint: string
        if (!is_null($statutaire_zetel) && !is_string($statutaire_zetel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statutaire_zetel, true), gettype($statutaire_zetel)), __LINE__);
        }
        $this->statutaire_zetel = $statutaire_zetel;
        return $this;
    }
    /**
     * Get rechtsvorm value
     * @return string|null
     */
    public function getRechtsvorm()
    {
        return $this->rechtsvorm;
    }
    /**
     * Set rechtsvorm value
     * @param string $rechtsvorm
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setRechtsvorm($rechtsvorm = null)
    {
        // validation for constraint: string
        if (!is_null($rechtsvorm) && !is_string($rechtsvorm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rechtsvorm, true), gettype($rechtsvorm)), __LINE__);
        }
        $this->rechtsvorm = $rechtsvorm;
        return $this;
    }
    /**
     * Get dossier_nummer value
     * @return string|null
     */
    public function getDossier_nummer()
    {
        return $this->dossier_nummer;
    }
    /**
     * Set dossier_nummer value
     * @param string $dossier_nummer
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setDossier_nummer($dossier_nummer = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_nummer) && !is_string($dossier_nummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_nummer, true), gettype($dossier_nummer)), __LINE__);
        }
        $this->dossier_nummer = $dossier_nummer;
        return $this;
    }
    /**
     * Get rsin value
     * @return string|null
     */
    public function getRsin()
    {
        return $this->rsin;
    }
    /**
     * Set rsin value
     * @param string $rsin
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setRsin($rsin = null)
    {
        // validation for constraint: string
        if (!is_null($rsin) && !is_string($rsin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rsin, true), gettype($rsin)), __LINE__);
        }
        $this->rsin = $rsin;
        return $this;
    }
    /**
     * Get postlocatie value
     * @return \StructType\KadasterV2AdresLocatie|null
     */
    public function getPostlocatie()
    {
        return $this->postlocatie;
    }
    /**
     * Set postlocatie value
     * @param \StructType\KadasterV2AdresLocatie $postlocatie
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setPostlocatie(\StructType\KadasterV2AdresLocatie $postlocatie = null)
    {
        $this->postlocatie = $postlocatie;
        return $this;
    }
    /**
     * Get woonlocatie value
     * @return \StructType\KadasterV2AdresLocatie|null
     */
    public function getWoonlocatie()
    {
        return $this->woonlocatie;
    }
    /**
     * Set woonlocatie value
     * @param \StructType\KadasterV2AdresLocatie $woonlocatie
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setWoonlocatie(\StructType\KadasterV2AdresLocatie $woonlocatie = null)
    {
        $this->woonlocatie = $woonlocatie;
        return $this;
    }
    /**
     * Get vermeld_in value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getVermeld_in()
    {
        return $this->vermeld_in;
    }
    /**
     * Set vermeld_in value
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setVermeld_in(\ArrayType\KadasterV2StukdeelArray $vermeld_in = null)
    {
        $this->vermeld_in = $vermeld_in;
        return $this;
    }
    /**
     * Get aanvullingen value
     * @return \ArrayType\KadasterV2AanvullingArray|null
     */
    public function getAanvullingen()
    {
        return $this->aanvullingen;
    }
    /**
     * Set aanvullingen value
     * @param \ArrayType\KadasterV2AanvullingArray $aanvullingen
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public function setAanvullingen(\ArrayType\KadasterV2AanvullingArray $aanvullingen = null)
    {
        $this->aanvullingen = $aanvullingen;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
