<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Stuk StructType
 * @subpackage Structs
 */
class KadasterV2Stuk extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The indicatie_correctie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $indicatie_correctie;
    /**
     * The toelichting_bewaarder
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $toelichting_bewaarder;
    /**
     * The acg_identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2AcgIdentificatie
     */
    public $acg_identificatie;
    /**
     * The stukdelen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $stukdelen;
    /**
     * The bijlages
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2BijlageArray
     */
    public $bijlages;
    /**
     * Constructor method for KadasterV2Stuk
     * @uses KadasterV2Stuk::setIdentificatie()
     * @uses KadasterV2Stuk::setIndicatie_correctie()
     * @uses KadasterV2Stuk::setToelichting_bewaarder()
     * @uses KadasterV2Stuk::setAcg_identificatie()
     * @uses KadasterV2Stuk::setStukdelen()
     * @uses KadasterV2Stuk::setBijlages()
     * @param string $identificatie
     * @param bool $indicatie_correctie
     * @param string $toelichting_bewaarder
     * @param \StructType\KadasterV2AcgIdentificatie $acg_identificatie
     * @param \ArrayType\KadasterV2StukdeelArray $stukdelen
     * @param \ArrayType\KadasterV2BijlageArray $bijlages
     */
    public function __construct($identificatie = null, $indicatie_correctie = null, $toelichting_bewaarder = null, \StructType\KadasterV2AcgIdentificatie $acg_identificatie = null, \ArrayType\KadasterV2StukdeelArray $stukdelen = null, \ArrayType\KadasterV2BijlageArray $bijlages = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setIndicatie_correctie($indicatie_correctie)
            ->setToelichting_bewaarder($toelichting_bewaarder)
            ->setAcg_identificatie($acg_identificatie)
            ->setStukdelen($stukdelen)
            ->setBijlages($bijlages);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Stuk
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get indicatie_correctie value
     * @return bool|null
     */
    public function getIndicatie_correctie()
    {
        return $this->indicatie_correctie;
    }
    /**
     * Set indicatie_correctie value
     * @param bool $indicatie_correctie
     * @return \StructType\KadasterV2Stuk
     */
    public function setIndicatie_correctie($indicatie_correctie = null)
    {
        // validation for constraint: boolean
        if (!is_null($indicatie_correctie) && !is_bool($indicatie_correctie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($indicatie_correctie, true), gettype($indicatie_correctie)), __LINE__);
        }
        $this->indicatie_correctie = $indicatie_correctie;
        return $this;
    }
    /**
     * Get toelichting_bewaarder value
     * @return string|null
     */
    public function getToelichting_bewaarder()
    {
        return $this->toelichting_bewaarder;
    }
    /**
     * Set toelichting_bewaarder value
     * @param string $toelichting_bewaarder
     * @return \StructType\KadasterV2Stuk
     */
    public function setToelichting_bewaarder($toelichting_bewaarder = null)
    {
        // validation for constraint: string
        if (!is_null($toelichting_bewaarder) && !is_string($toelichting_bewaarder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($toelichting_bewaarder, true), gettype($toelichting_bewaarder)), __LINE__);
        }
        $this->toelichting_bewaarder = $toelichting_bewaarder;
        return $this;
    }
    /**
     * Get acg_identificatie value
     * @return \StructType\KadasterV2AcgIdentificatie|null
     */
    public function getAcg_identificatie()
    {
        return $this->acg_identificatie;
    }
    /**
     * Set acg_identificatie value
     * @param \StructType\KadasterV2AcgIdentificatie $acg_identificatie
     * @return \StructType\KadasterV2Stuk
     */
    public function setAcg_identificatie(\StructType\KadasterV2AcgIdentificatie $acg_identificatie = null)
    {
        $this->acg_identificatie = $acg_identificatie;
        return $this;
    }
    /**
     * Get stukdelen value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getStukdelen()
    {
        return $this->stukdelen;
    }
    /**
     * Set stukdelen value
     * @param \ArrayType\KadasterV2StukdeelArray $stukdelen
     * @return \StructType\KadasterV2Stuk
     */
    public function setStukdelen(\ArrayType\KadasterV2StukdeelArray $stukdelen = null)
    {
        $this->stukdelen = $stukdelen;
        return $this;
    }
    /**
     * Get bijlages value
     * @return \ArrayType\KadasterV2BijlageArray|null
     */
    public function getBijlages()
    {
        return $this->bijlages;
    }
    /**
     * Set bijlages value
     * @param \ArrayType\KadasterV2BijlageArray $bijlages
     * @return \StructType\KadasterV2Stuk
     */
    public function setBijlages(\ArrayType\KadasterV2BijlageArray $bijlages = null)
    {
        $this->bijlages = $bijlages;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2Stuk
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
