<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Tenaamstelling StructType
 * @subpackage Structs
 */
class KadasterV2Tenaamstelling extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The aandeel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Breuk
     */
    public $aandeel;
    /**
     * The burgerlijke_staat_ten_tijde_van_verkrijging
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $burgerlijke_staat_ten_tijde_van_verkrijging;
    /**
     * The omschrijving
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $omschrijving;
    /**
     * The verklaring_inzake_derden_bescherming
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $verklaring_inzake_derden_bescherming;
    /**
     * The verkregen_namens_samenwerkingsverband
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $verkregen_namens_samenwerkingsverband;
    /**
     * The betrokken_partner
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Personen
     */
    public $betrokken_partner;
    /**
     * The betrokken_samenwerkingsverband
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Personen
     */
    public $betrokken_samenwerkingsverband;
    /**
     * The van
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2ZakelijkRecht
     */
    public $van;
    /**
     * The geldt_voor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2GezamenlijkAandeel
     */
    public $geldt_voor;
    /**
     * The gebaseerd_op
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $gebaseerd_op;
    /**
     * The vermeld_in
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $vermeld_in;
    /**
     * The ten_name_van
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Personen
     */
    public $ten_name_van;
    /**
     * Constructor method for KadasterV2Tenaamstelling
     * @uses KadasterV2Tenaamstelling::setIdentificatie()
     * @uses KadasterV2Tenaamstelling::setAandeel()
     * @uses KadasterV2Tenaamstelling::setBurgerlijke_staat_ten_tijde_van_verkrijging()
     * @uses KadasterV2Tenaamstelling::setOmschrijving()
     * @uses KadasterV2Tenaamstelling::setVerklaring_inzake_derden_bescherming()
     * @uses KadasterV2Tenaamstelling::setVerkregen_namens_samenwerkingsverband()
     * @uses KadasterV2Tenaamstelling::setBetrokken_partner()
     * @uses KadasterV2Tenaamstelling::setBetrokken_samenwerkingsverband()
     * @uses KadasterV2Tenaamstelling::setVan()
     * @uses KadasterV2Tenaamstelling::setGeldt_voor()
     * @uses KadasterV2Tenaamstelling::setGebaseerd_op()
     * @uses KadasterV2Tenaamstelling::setVermeld_in()
     * @uses KadasterV2Tenaamstelling::setTen_name_van()
     * @param string $identificatie
     * @param \StructType\KadasterV2Breuk $aandeel
     * @param string $burgerlijke_staat_ten_tijde_van_verkrijging
     * @param string $omschrijving
     * @param string $verklaring_inzake_derden_bescherming
     * @param string $verkregen_namens_samenwerkingsverband
     * @param \StructType\KadasterV2Personen $betrokken_partner
     * @param \StructType\KadasterV2Personen $betrokken_samenwerkingsverband
     * @param \StructType\KadasterV2ZakelijkRecht $van
     * @param \StructType\KadasterV2GezamenlijkAandeel $geldt_voor
     * @param \ArrayType\KadasterV2StukdeelArray $gebaseerd_op
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @param \StructType\KadasterV2Personen $ten_name_van
     */
    public function __construct($identificatie = null, \StructType\KadasterV2Breuk $aandeel = null, $burgerlijke_staat_ten_tijde_van_verkrijging = null, $omschrijving = null, $verklaring_inzake_derden_bescherming = null, $verkregen_namens_samenwerkingsverband = null, \StructType\KadasterV2Personen $betrokken_partner = null, \StructType\KadasterV2Personen $betrokken_samenwerkingsverband = null, \StructType\KadasterV2ZakelijkRecht $van = null, \StructType\KadasterV2GezamenlijkAandeel $geldt_voor = null, \ArrayType\KadasterV2StukdeelArray $gebaseerd_op = null, \ArrayType\KadasterV2StukdeelArray $vermeld_in = null, \StructType\KadasterV2Personen $ten_name_van = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setAandeel($aandeel)
            ->setBurgerlijke_staat_ten_tijde_van_verkrijging($burgerlijke_staat_ten_tijde_van_verkrijging)
            ->setOmschrijving($omschrijving)
            ->setVerklaring_inzake_derden_bescherming($verklaring_inzake_derden_bescherming)
            ->setVerkregen_namens_samenwerkingsverband($verkregen_namens_samenwerkingsverband)
            ->setBetrokken_partner($betrokken_partner)
            ->setBetrokken_samenwerkingsverband($betrokken_samenwerkingsverband)
            ->setVan($van)
            ->setGeldt_voor($geldt_voor)
            ->setGebaseerd_op($gebaseerd_op)
            ->setVermeld_in($vermeld_in)
            ->setTen_name_van($ten_name_van);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get aandeel value
     * @return \StructType\KadasterV2Breuk|null
     */
    public function getAandeel()
    {
        return $this->aandeel;
    }
    /**
     * Set aandeel value
     * @param \StructType\KadasterV2Breuk $aandeel
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setAandeel(\StructType\KadasterV2Breuk $aandeel = null)
    {
        $this->aandeel = $aandeel;
        return $this;
    }
    /**
     * Get burgerlijke_staat_ten_tijde_van_verkrijging value
     * @return string|null
     */
    public function getBurgerlijke_staat_ten_tijde_van_verkrijging()
    {
        return $this->burgerlijke_staat_ten_tijde_van_verkrijging;
    }
    /**
     * Set burgerlijke_staat_ten_tijde_van_verkrijging value
     * @param string $burgerlijke_staat_ten_tijde_van_verkrijging
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setBurgerlijke_staat_ten_tijde_van_verkrijging($burgerlijke_staat_ten_tijde_van_verkrijging = null)
    {
        // validation for constraint: string
        if (!is_null($burgerlijke_staat_ten_tijde_van_verkrijging) && !is_string($burgerlijke_staat_ten_tijde_van_verkrijging)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($burgerlijke_staat_ten_tijde_van_verkrijging, true), gettype($burgerlijke_staat_ten_tijde_van_verkrijging)), __LINE__);
        }
        $this->burgerlijke_staat_ten_tijde_van_verkrijging = $burgerlijke_staat_ten_tijde_van_verkrijging;
        return $this;
    }
    /**
     * Get omschrijving value
     * @return string|null
     */
    public function getOmschrijving()
    {
        return $this->omschrijving;
    }
    /**
     * Set omschrijving value
     * @param string $omschrijving
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setOmschrijving($omschrijving = null)
    {
        // validation for constraint: string
        if (!is_null($omschrijving) && !is_string($omschrijving)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($omschrijving, true), gettype($omschrijving)), __LINE__);
        }
        $this->omschrijving = $omschrijving;
        return $this;
    }
    /**
     * Get verklaring_inzake_derden_bescherming value
     * @return string|null
     */
    public function getVerklaring_inzake_derden_bescherming()
    {
        return $this->verklaring_inzake_derden_bescherming;
    }
    /**
     * Set verklaring_inzake_derden_bescherming value
     * @param string $verklaring_inzake_derden_bescherming
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setVerklaring_inzake_derden_bescherming($verklaring_inzake_derden_bescherming = null)
    {
        // validation for constraint: string
        if (!is_null($verklaring_inzake_derden_bescherming) && !is_string($verklaring_inzake_derden_bescherming)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($verklaring_inzake_derden_bescherming, true), gettype($verklaring_inzake_derden_bescherming)), __LINE__);
        }
        $this->verklaring_inzake_derden_bescherming = $verklaring_inzake_derden_bescherming;
        return $this;
    }
    /**
     * Get verkregen_namens_samenwerkingsverband value
     * @return string|null
     */
    public function getVerkregen_namens_samenwerkingsverband()
    {
        return $this->verkregen_namens_samenwerkingsverband;
    }
    /**
     * Set verkregen_namens_samenwerkingsverband value
     * @param string $verkregen_namens_samenwerkingsverband
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setVerkregen_namens_samenwerkingsverband($verkregen_namens_samenwerkingsverband = null)
    {
        // validation for constraint: string
        if (!is_null($verkregen_namens_samenwerkingsverband) && !is_string($verkregen_namens_samenwerkingsverband)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($verkregen_namens_samenwerkingsverband, true), gettype($verkregen_namens_samenwerkingsverband)), __LINE__);
        }
        $this->verkregen_namens_samenwerkingsverband = $verkregen_namens_samenwerkingsverband;
        return $this;
    }
    /**
     * Get betrokken_partner value
     * @return \StructType\KadasterV2Personen|null
     */
    public function getBetrokken_partner()
    {
        return $this->betrokken_partner;
    }
    /**
     * Set betrokken_partner value
     * @param \StructType\KadasterV2Personen $betrokken_partner
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setBetrokken_partner(\StructType\KadasterV2Personen $betrokken_partner = null)
    {
        $this->betrokken_partner = $betrokken_partner;
        return $this;
    }
    /**
     * Get betrokken_samenwerkingsverband value
     * @return \StructType\KadasterV2Personen|null
     */
    public function getBetrokken_samenwerkingsverband()
    {
        return $this->betrokken_samenwerkingsverband;
    }
    /**
     * Set betrokken_samenwerkingsverband value
     * @param \StructType\KadasterV2Personen $betrokken_samenwerkingsverband
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setBetrokken_samenwerkingsverband(\StructType\KadasterV2Personen $betrokken_samenwerkingsverband = null)
    {
        $this->betrokken_samenwerkingsverband = $betrokken_samenwerkingsverband;
        return $this;
    }
    /**
     * Get van value
     * @return \StructType\KadasterV2ZakelijkRecht|null
     */
    public function getVan()
    {
        return $this->van;
    }
    /**
     * Set van value
     * @param \StructType\KadasterV2ZakelijkRecht $van
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setVan(\StructType\KadasterV2ZakelijkRecht $van = null)
    {
        $this->van = $van;
        return $this;
    }
    /**
     * Get geldt_voor value
     * @return \StructType\KadasterV2GezamenlijkAandeel|null
     */
    public function getGeldt_voor()
    {
        return $this->geldt_voor;
    }
    /**
     * Set geldt_voor value
     * @param \StructType\KadasterV2GezamenlijkAandeel $geldt_voor
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setGeldt_voor(\StructType\KadasterV2GezamenlijkAandeel $geldt_voor = null)
    {
        $this->geldt_voor = $geldt_voor;
        return $this;
    }
    /**
     * Get gebaseerd_op value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getGebaseerd_op()
    {
        return $this->gebaseerd_op;
    }
    /**
     * Set gebaseerd_op value
     * @param \ArrayType\KadasterV2StukdeelArray $gebaseerd_op
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setGebaseerd_op(\ArrayType\KadasterV2StukdeelArray $gebaseerd_op = null)
    {
        $this->gebaseerd_op = $gebaseerd_op;
        return $this;
    }
    /**
     * Get vermeld_in value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getVermeld_in()
    {
        return $this->vermeld_in;
    }
    /**
     * Set vermeld_in value
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setVermeld_in(\ArrayType\KadasterV2StukdeelArray $vermeld_in = null)
    {
        $this->vermeld_in = $vermeld_in;
        return $this;
    }
    /**
     * Get ten_name_van value
     * @return \StructType\KadasterV2Personen|null
     */
    public function getTen_name_van()
    {
        return $this->ten_name_van;
    }
    /**
     * Set ten_name_van value
     * @param \StructType\KadasterV2Personen $ten_name_van
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public function setTen_name_van(\StructType\KadasterV2Personen $ten_name_van = null)
    {
        $this->ten_name_van = $ten_name_van;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2Tenaamstelling
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
