<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterValueList StructType
 * @subpackage Structs
 */
class KadasterValueList extends AbstractStructBase
{
    /**
     * The list
     * @var \ArrayType\KadasterListValueArray
     */
    public $list;
    /**
     * Constructor method for KadasterValueList
     * @uses KadasterValueList::setList()
     * @param \ArrayType\KadasterListValueArray $list
     */
    public function __construct(\ArrayType\KadasterListValueArray $list = null)
    {
        $this
            ->setList($list);
    }
    /**
     * Get list value
     * @return \ArrayType\KadasterListValueArray|null
     */
    public function getList()
    {
        return $this->list;
    }
    /**
     * Set list value
     * @param \ArrayType\KadasterListValueArray $list
     * @return \StructType\KadasterValueList
     */
    public function setList(\ArrayType\KadasterListValueArray $list = null)
    {
        $this->list = $list;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterValueList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
