<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PerceelSearchPartsPagedResult StructType
 * @subpackage Structs
 */
class PerceelSearchPartsPagedResult extends AbstractStructBase
{
    /**
     * The extra
     * @var \StructType\SearchParts
     */
    public $extra;
    /**
     * The paging
     * @var \StructType\ResultInfo
     */
    public $paging;
    /**
     * The results
     * @var \ArrayType\PerceelArray
     */
    public $results;
    /**
     * Constructor method for PerceelSearchPartsPagedResult
     * @uses PerceelSearchPartsPagedResult::setExtra()
     * @uses PerceelSearchPartsPagedResult::setPaging()
     * @uses PerceelSearchPartsPagedResult::setResults()
     * @param \StructType\SearchParts $extra
     * @param \StructType\ResultInfo $paging
     * @param \ArrayType\PerceelArray $results
     */
    public function __construct(\StructType\SearchParts $extra = null, \StructType\ResultInfo $paging = null, \ArrayType\PerceelArray $results = null)
    {
        $this
            ->setExtra($extra)
            ->setPaging($paging)
            ->setResults($results);
    }
    /**
     * Get extra value
     * @return \StructType\SearchParts|null
     */
    public function getExtra()
    {
        return $this->extra;
    }
    /**
     * Set extra value
     * @param \StructType\SearchParts $extra
     * @return \StructType\PerceelSearchPartsPagedResult
     */
    public function setExtra(\StructType\SearchParts $extra = null)
    {
        $this->extra = $extra;
        return $this;
    }
    /**
     * Get paging value
     * @return \StructType\ResultInfo|null
     */
    public function getPaging()
    {
        return $this->paging;
    }
    /**
     * Set paging value
     * @param \StructType\ResultInfo $paging
     * @return \StructType\PerceelSearchPartsPagedResult
     */
    public function setPaging(\StructType\ResultInfo $paging = null)
    {
        $this->paging = $paging;
        return $this;
    }
    /**
     * Get results value
     * @return \ArrayType\PerceelArray|null
     */
    public function getResults()
    {
        return $this->results;
    }
    /**
     * Set results value
     * @param \ArrayType\PerceelArray $results
     * @return \StructType\PerceelSearchPartsPagedResult
     */
    public function setResults(\ArrayType\PerceelArray $results = null)
    {
        $this->results = $results;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PerceelSearchPartsPagedResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
