<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Persoon StructType
 * @subpackage Structs
 */
class Persoon extends AbstractStructBase
{
    /**
     * The id
     * @var string
     */
    public $id;
    /**
     * The natuurlijk_persoon
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NatuurlijkPersoon
     */
    public $natuurlijk_persoon;
    /**
     * The niet_natuurlijk_persoon
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NietNatuurlijkPersoon
     */
    public $niet_natuurlijk_persoon;
    /**
     * The aantekening_beschikkingsbevoegdheid
     * @var bool
     */
    public $aantekening_beschikkingsbevoegdheid;
    /**
     * The indicatie_meer_onroerende_zaken
     * @var bool
     */
    public $indicatie_meer_onroerende_zaken;
    /**
     * The woonlocatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Locatie
     */
    public $woonlocatie;
    /**
     * The postlocatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Locatie
     */
    public $postlocatie;
    /**
     * The niet_volledig_verwerkt_stukken_lijst
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\StukReferentiesLijst
     */
    public $niet_volledig_verwerkt_stukken_lijst;
    /**
     * The mogelijk_van_belang_stukken_lijst
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\StukReferentiesLijst
     */
    public $mogelijk_van_belang_stukken_lijst;
    /**
     * Constructor method for Persoon
     * @uses Persoon::setId()
     * @uses Persoon::setNatuurlijk_persoon()
     * @uses Persoon::setNiet_natuurlijk_persoon()
     * @uses Persoon::setAantekening_beschikkingsbevoegdheid()
     * @uses Persoon::setIndicatie_meer_onroerende_zaken()
     * @uses Persoon::setWoonlocatie()
     * @uses Persoon::setPostlocatie()
     * @uses Persoon::setNiet_volledig_verwerkt_stukken_lijst()
     * @uses Persoon::setMogelijk_van_belang_stukken_lijst()
     * @param string $id
     * @param \StructType\NatuurlijkPersoon $natuurlijk_persoon
     * @param \StructType\NietNatuurlijkPersoon $niet_natuurlijk_persoon
     * @param bool $aantekening_beschikkingsbevoegdheid
     * @param bool $indicatie_meer_onroerende_zaken
     * @param \StructType\Locatie $woonlocatie
     * @param \StructType\Locatie $postlocatie
     * @param \StructType\StukReferentiesLijst $niet_volledig_verwerkt_stukken_lijst
     * @param \StructType\StukReferentiesLijst $mogelijk_van_belang_stukken_lijst
     */
    public function __construct($id = null, \StructType\NatuurlijkPersoon $natuurlijk_persoon = null, \StructType\NietNatuurlijkPersoon $niet_natuurlijk_persoon = null, $aantekening_beschikkingsbevoegdheid = null, $indicatie_meer_onroerende_zaken = null, \StructType\Locatie $woonlocatie = null, \StructType\Locatie $postlocatie = null, \StructType\StukReferentiesLijst $niet_volledig_verwerkt_stukken_lijst = null, \StructType\StukReferentiesLijst $mogelijk_van_belang_stukken_lijst = null)
    {
        $this
            ->setId($id)
            ->setNatuurlijk_persoon($natuurlijk_persoon)
            ->setNiet_natuurlijk_persoon($niet_natuurlijk_persoon)
            ->setAantekening_beschikkingsbevoegdheid($aantekening_beschikkingsbevoegdheid)
            ->setIndicatie_meer_onroerende_zaken($indicatie_meer_onroerende_zaken)
            ->setWoonlocatie($woonlocatie)
            ->setPostlocatie($postlocatie)
            ->setNiet_volledig_verwerkt_stukken_lijst($niet_volledig_verwerkt_stukken_lijst)
            ->setMogelijk_van_belang_stukken_lijst($mogelijk_van_belang_stukken_lijst);
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\Persoon
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get natuurlijk_persoon value
     * @return \StructType\NatuurlijkPersoon|null
     */
    public function getNatuurlijk_persoon()
    {
        return $this->natuurlijk_persoon;
    }
    /**
     * Set natuurlijk_persoon value
     * @param \StructType\NatuurlijkPersoon $natuurlijk_persoon
     * @return \StructType\Persoon
     */
    public function setNatuurlijk_persoon(\StructType\NatuurlijkPersoon $natuurlijk_persoon = null)
    {
        $this->natuurlijk_persoon = $natuurlijk_persoon;
        return $this;
    }
    /**
     * Get niet_natuurlijk_persoon value
     * @return \StructType\NietNatuurlijkPersoon|null
     */
    public function getNiet_natuurlijk_persoon()
    {
        return $this->niet_natuurlijk_persoon;
    }
    /**
     * Set niet_natuurlijk_persoon value
     * @param \StructType\NietNatuurlijkPersoon $niet_natuurlijk_persoon
     * @return \StructType\Persoon
     */
    public function setNiet_natuurlijk_persoon(\StructType\NietNatuurlijkPersoon $niet_natuurlijk_persoon = null)
    {
        $this->niet_natuurlijk_persoon = $niet_natuurlijk_persoon;
        return $this;
    }
    /**
     * Get aantekening_beschikkingsbevoegdheid value
     * @return bool|null
     */
    public function getAantekening_beschikkingsbevoegdheid()
    {
        return $this->aantekening_beschikkingsbevoegdheid;
    }
    /**
     * Set aantekening_beschikkingsbevoegdheid value
     * @param bool $aantekening_beschikkingsbevoegdheid
     * @return \StructType\Persoon
     */
    public function setAantekening_beschikkingsbevoegdheid($aantekening_beschikkingsbevoegdheid = null)
    {
        // validation for constraint: boolean
        if (!is_null($aantekening_beschikkingsbevoegdheid) && !is_bool($aantekening_beschikkingsbevoegdheid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($aantekening_beschikkingsbevoegdheid, true), gettype($aantekening_beschikkingsbevoegdheid)), __LINE__);
        }
        $this->aantekening_beschikkingsbevoegdheid = $aantekening_beschikkingsbevoegdheid;
        return $this;
    }
    /**
     * Get indicatie_meer_onroerende_zaken value
     * @return bool|null
     */
    public function getIndicatie_meer_onroerende_zaken()
    {
        return $this->indicatie_meer_onroerende_zaken;
    }
    /**
     * Set indicatie_meer_onroerende_zaken value
     * @param bool $indicatie_meer_onroerende_zaken
     * @return \StructType\Persoon
     */
    public function setIndicatie_meer_onroerende_zaken($indicatie_meer_onroerende_zaken = null)
    {
        // validation for constraint: boolean
        if (!is_null($indicatie_meer_onroerende_zaken) && !is_bool($indicatie_meer_onroerende_zaken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($indicatie_meer_onroerende_zaken, true), gettype($indicatie_meer_onroerende_zaken)), __LINE__);
        }
        $this->indicatie_meer_onroerende_zaken = $indicatie_meer_onroerende_zaken;
        return $this;
    }
    /**
     * Get woonlocatie value
     * @return \StructType\Locatie|null
     */
    public function getWoonlocatie()
    {
        return $this->woonlocatie;
    }
    /**
     * Set woonlocatie value
     * @param \StructType\Locatie $woonlocatie
     * @return \StructType\Persoon
     */
    public function setWoonlocatie(\StructType\Locatie $woonlocatie = null)
    {
        $this->woonlocatie = $woonlocatie;
        return $this;
    }
    /**
     * Get postlocatie value
     * @return \StructType\Locatie|null
     */
    public function getPostlocatie()
    {
        return $this->postlocatie;
    }
    /**
     * Set postlocatie value
     * @param \StructType\Locatie $postlocatie
     * @return \StructType\Persoon
     */
    public function setPostlocatie(\StructType\Locatie $postlocatie = null)
    {
        $this->postlocatie = $postlocatie;
        return $this;
    }
    /**
     * Get niet_volledig_verwerkt_stukken_lijst value
     * @return \StructType\StukReferentiesLijst|null
     */
    public function getNiet_volledig_verwerkt_stukken_lijst()
    {
        return $this->niet_volledig_verwerkt_stukken_lijst;
    }
    /**
     * Set niet_volledig_verwerkt_stukken_lijst value
     * @param \StructType\StukReferentiesLijst $niet_volledig_verwerkt_stukken_lijst
     * @return \StructType\Persoon
     */
    public function setNiet_volledig_verwerkt_stukken_lijst(\StructType\StukReferentiesLijst $niet_volledig_verwerkt_stukken_lijst = null)
    {
        $this->niet_volledig_verwerkt_stukken_lijst = $niet_volledig_verwerkt_stukken_lijst;
        return $this;
    }
    /**
     * Get mogelijk_van_belang_stukken_lijst value
     * @return \StructType\StukReferentiesLijst|null
     */
    public function getMogelijk_van_belang_stukken_lijst()
    {
        return $this->mogelijk_van_belang_stukken_lijst;
    }
    /**
     * Set mogelijk_van_belang_stukken_lijst value
     * @param \StructType\StukReferentiesLijst $mogelijk_van_belang_stukken_lijst
     * @return \StructType\Persoon
     */
    public function setMogelijk_van_belang_stukken_lijst(\StructType\StukReferentiesLijst $mogelijk_van_belang_stukken_lijst = null)
    {
        $this->mogelijk_van_belang_stukken_lijst = $mogelijk_van_belang_stukken_lijst;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Persoon
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
