<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RiskCompanyReport StructType
 * @subpackage Structs
 */
class RiskCompanyReport extends AbstractStructBase
{
    /**
     * The companies
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\RiskCompanyArray
     */
    public $companies;
    /**
     * The insolvencies
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\RiskInsolvencyArray
     */
    public $insolvencies;
    /**
     * The legal_restraint
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RiskLegalRestraint
     */
    public $legal_restraint;
    /**
     * Constructor method for RiskCompanyReport
     * @uses RiskCompanyReport::setCompanies()
     * @uses RiskCompanyReport::setInsolvencies()
     * @uses RiskCompanyReport::setLegal_restraint()
     * @param \ArrayType\RiskCompanyArray $companies
     * @param \ArrayType\RiskInsolvencyArray $insolvencies
     * @param \StructType\RiskLegalRestraint $legal_restraint
     */
    public function __construct(\ArrayType\RiskCompanyArray $companies = null, \ArrayType\RiskInsolvencyArray $insolvencies = null, \StructType\RiskLegalRestraint $legal_restraint = null)
    {
        $this
            ->setCompanies($companies)
            ->setInsolvencies($insolvencies)
            ->setLegal_restraint($legal_restraint);
    }
    /**
     * Get companies value
     * @return \ArrayType\RiskCompanyArray|null
     */
    public function getCompanies()
    {
        return $this->companies;
    }
    /**
     * Set companies value
     * @param \ArrayType\RiskCompanyArray $companies
     * @return \StructType\RiskCompanyReport
     */
    public function setCompanies(\ArrayType\RiskCompanyArray $companies = null)
    {
        $this->companies = $companies;
        return $this;
    }
    /**
     * Get insolvencies value
     * @return \ArrayType\RiskInsolvencyArray|null
     */
    public function getInsolvencies()
    {
        return $this->insolvencies;
    }
    /**
     * Set insolvencies value
     * @param \ArrayType\RiskInsolvencyArray $insolvencies
     * @return \StructType\RiskCompanyReport
     */
    public function setInsolvencies(\ArrayType\RiskInsolvencyArray $insolvencies = null)
    {
        $this->insolvencies = $insolvencies;
        return $this;
    }
    /**
     * Get legal_restraint value
     * @return \StructType\RiskLegalRestraint|null
     */
    public function getLegal_restraint()
    {
        return $this->legal_restraint;
    }
    /**
     * Set legal_restraint value
     * @param \StructType\RiskLegalRestraint $legal_restraint
     * @return \StructType\RiskCompanyReport
     */
    public function setLegal_restraint(\StructType\RiskLegalRestraint $legal_restraint = null)
    {
        $this->legal_restraint = $legal_restraint;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RiskCompanyReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
