<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RiskLegalRestraint StructType
 * @subpackage Structs
 */
class RiskLegalRestraint extends AbstractStructBase
{
    /**
     * The verdict_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $verdict_number;
    /**
     * The person
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RiskLegalRestraintPerson
     */
    public $person;
    /**
     * The registry
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RiskLegalRestraintRegistry
     */
    public $registry;
    /**
     * The decisions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\RiskLegalRestraintDecisionArray
     */
    public $decisions;
    /**
     * Constructor method for RiskLegalRestraint
     * @uses RiskLegalRestraint::setVerdict_number()
     * @uses RiskLegalRestraint::setPerson()
     * @uses RiskLegalRestraint::setRegistry()
     * @uses RiskLegalRestraint::setDecisions()
     * @param string $verdict_number
     * @param \StructType\RiskLegalRestraintPerson $person
     * @param \StructType\RiskLegalRestraintRegistry $registry
     * @param \ArrayType\RiskLegalRestraintDecisionArray $decisions
     */
    public function __construct($verdict_number = null, \StructType\RiskLegalRestraintPerson $person = null, \StructType\RiskLegalRestraintRegistry $registry = null, \ArrayType\RiskLegalRestraintDecisionArray $decisions = null)
    {
        $this
            ->setVerdict_number($verdict_number)
            ->setPerson($person)
            ->setRegistry($registry)
            ->setDecisions($decisions);
    }
    /**
     * Get verdict_number value
     * @return string|null
     */
    public function getVerdict_number()
    {
        return $this->verdict_number;
    }
    /**
     * Set verdict_number value
     * @param string $verdict_number
     * @return \StructType\RiskLegalRestraint
     */
    public function setVerdict_number($verdict_number = null)
    {
        // validation for constraint: string
        if (!is_null($verdict_number) && !is_string($verdict_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($verdict_number, true), gettype($verdict_number)), __LINE__);
        }
        $this->verdict_number = $verdict_number;
        return $this;
    }
    /**
     * Get person value
     * @return \StructType\RiskLegalRestraintPerson|null
     */
    public function getPerson()
    {
        return $this->person;
    }
    /**
     * Set person value
     * @param \StructType\RiskLegalRestraintPerson $person
     * @return \StructType\RiskLegalRestraint
     */
    public function setPerson(\StructType\RiskLegalRestraintPerson $person = null)
    {
        $this->person = $person;
        return $this;
    }
    /**
     * Get registry value
     * @return \StructType\RiskLegalRestraintRegistry|null
     */
    public function getRegistry()
    {
        return $this->registry;
    }
    /**
     * Set registry value
     * @param \StructType\RiskLegalRestraintRegistry $registry
     * @return \StructType\RiskLegalRestraint
     */
    public function setRegistry(\StructType\RiskLegalRestraintRegistry $registry = null)
    {
        $this->registry = $registry;
        return $this;
    }
    /**
     * Get decisions value
     * @return \ArrayType\RiskLegalRestraintDecisionArray|null
     */
    public function getDecisions()
    {
        return $this->decisions;
    }
    /**
     * Set decisions value
     * @param \ArrayType\RiskLegalRestraintDecisionArray $decisions
     * @return \StructType\RiskLegalRestraint
     */
    public function setDecisions(\ArrayType\RiskLegalRestraintDecisionArray $decisions = null)
    {
        $this->decisions = $decisions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RiskLegalRestraint
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
