<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RouteDescriptionCoordinatesRD StructType
 * @subpackage Structs
 */
class RouteDescriptionCoordinatesRD extends AbstractStructBase
{
    /**
     * The routecoordinates
     * @var \StructType\RouteCoordinatesRD
     */
    public $routecoordinates;
    /**
     * The parts
     * @var \ArrayType\RoutePartArray
     */
    public $parts;
    /**
     * Constructor method for RouteDescriptionCoordinatesRD
     * @uses RouteDescriptionCoordinatesRD::setRoutecoordinates()
     * @uses RouteDescriptionCoordinatesRD::setParts()
     * @param \StructType\RouteCoordinatesRD $routecoordinates
     * @param \ArrayType\RoutePartArray $parts
     */
    public function __construct(\StructType\RouteCoordinatesRD $routecoordinates = null, \ArrayType\RoutePartArray $parts = null)
    {
        $this
            ->setRoutecoordinates($routecoordinates)
            ->setParts($parts);
    }
    /**
     * Get routecoordinates value
     * @return \StructType\RouteCoordinatesRD|null
     */
    public function getRoutecoordinates()
    {
        return $this->routecoordinates;
    }
    /**
     * Set routecoordinates value
     * @param \StructType\RouteCoordinatesRD $routecoordinates
     * @return \StructType\RouteDescriptionCoordinatesRD
     */
    public function setRoutecoordinates(\StructType\RouteCoordinatesRD $routecoordinates = null)
    {
        $this->routecoordinates = $routecoordinates;
        return $this;
    }
    /**
     * Get parts value
     * @return \ArrayType\RoutePartArray|null
     */
    public function getParts()
    {
        return $this->parts;
    }
    /**
     * Set parts value
     * @param \ArrayType\RoutePartArray $parts
     * @return \StructType\RouteDescriptionCoordinatesRD
     */
    public function setParts(\ArrayType\RoutePartArray $parts = null)
    {
        $this->parts = $parts;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RouteDescriptionCoordinatesRD
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
