<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for routePlannerRDDescriptionRequestType StructType
 * @subpackage Structs
 */
class RoutePlannerRDDescriptionRequestType extends AbstractStructBase
{
    /**
     * The xfrom
     * @var int
     */
    public $xfrom;
    /**
     * The yfrom
     * @var int
     */
    public $yfrom;
    /**
     * The xto
     * @var int
     */
    public $xto;
    /**
     * The yto
     * @var int
     */
    public $yto;
    /**
     * The routetype
     * @var string
     */
    public $routetype;
    /**
     * The english
     * @var bool
     */
    public $english;
    /**
     * Constructor method for routePlannerRDDescriptionRequestType
     * @uses RoutePlannerRDDescriptionRequestType::setXfrom()
     * @uses RoutePlannerRDDescriptionRequestType::setYfrom()
     * @uses RoutePlannerRDDescriptionRequestType::setXto()
     * @uses RoutePlannerRDDescriptionRequestType::setYto()
     * @uses RoutePlannerRDDescriptionRequestType::setRoutetype()
     * @uses RoutePlannerRDDescriptionRequestType::setEnglish()
     * @param int $xfrom
     * @param int $yfrom
     * @param int $xto
     * @param int $yto
     * @param string $routetype
     * @param bool $english
     */
    public function __construct($xfrom = null, $yfrom = null, $xto = null, $yto = null, $routetype = null, $english = null)
    {
        $this
            ->setXfrom($xfrom)
            ->setYfrom($yfrom)
            ->setXto($xto)
            ->setYto($yto)
            ->setRoutetype($routetype)
            ->setEnglish($english);
    }
    /**
     * Get xfrom value
     * @return int|null
     */
    public function getXfrom()
    {
        return $this->xfrom;
    }
    /**
     * Set xfrom value
     * @param int $xfrom
     * @return \StructType\RoutePlannerRDDescriptionRequestType
     */
    public function setXfrom($xfrom = null)
    {
        // validation for constraint: int
        if (!is_null($xfrom) && !(is_int($xfrom) || ctype_digit($xfrom))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($xfrom, true), gettype($xfrom)), __LINE__);
        }
        $this->xfrom = $xfrom;
        return $this;
    }
    /**
     * Get yfrom value
     * @return int|null
     */
    public function getYfrom()
    {
        return $this->yfrom;
    }
    /**
     * Set yfrom value
     * @param int $yfrom
     * @return \StructType\RoutePlannerRDDescriptionRequestType
     */
    public function setYfrom($yfrom = null)
    {
        // validation for constraint: int
        if (!is_null($yfrom) && !(is_int($yfrom) || ctype_digit($yfrom))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($yfrom, true), gettype($yfrom)), __LINE__);
        }
        $this->yfrom = $yfrom;
        return $this;
    }
    /**
     * Get xto value
     * @return int|null
     */
    public function getXto()
    {
        return $this->xto;
    }
    /**
     * Set xto value
     * @param int $xto
     * @return \StructType\RoutePlannerRDDescriptionRequestType
     */
    public function setXto($xto = null)
    {
        // validation for constraint: int
        if (!is_null($xto) && !(is_int($xto) || ctype_digit($xto))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($xto, true), gettype($xto)), __LINE__);
        }
        $this->xto = $xto;
        return $this;
    }
    /**
     * Get yto value
     * @return int|null
     */
    public function getYto()
    {
        return $this->yto;
    }
    /**
     * Set yto value
     * @param int $yto
     * @return \StructType\RoutePlannerRDDescriptionRequestType
     */
    public function setYto($yto = null)
    {
        // validation for constraint: int
        if (!is_null($yto) && !(is_int($yto) || ctype_digit($yto))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($yto, true), gettype($yto)), __LINE__);
        }
        $this->yto = $yto;
        return $this;
    }
    /**
     * Get routetype value
     * @return string|null
     */
    public function getRoutetype()
    {
        return $this->routetype;
    }
    /**
     * Set routetype value
     * @param string $routetype
     * @return \StructType\RoutePlannerRDDescriptionRequestType
     */
    public function setRoutetype($routetype = null)
    {
        // validation for constraint: string
        if (!is_null($routetype) && !is_string($routetype)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($routetype, true), gettype($routetype)), __LINE__);
        }
        $this->routetype = $routetype;
        return $this;
    }
    /**
     * Get english value
     * @return bool|null
     */
    public function getEnglish()
    {
        return $this->english;
    }
    /**
     * Set english value
     * @param bool $english
     * @return \StructType\RoutePlannerRDDescriptionRequestType
     */
    public function setEnglish($english = null)
    {
        // validation for constraint: boolean
        if (!is_null($english) && !is_bool($english)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($english, true), gettype($english)), __LINE__);
        }
        $this->english = $english;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RoutePlannerRDDescriptionRequestType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
