<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoutePlannerRoute StructType
 * @subpackage Structs
 */
class RoutePlannerRoute extends AbstractStructBase
{
    /**
     * The description
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \ArrayType\RoutePartArray
     */
    public $description;
    /**
     * The start
     * @var \StructType\RouteLocation
     */
    public $start;
    /**
     * The destination
     * @var \StructType\RouteLocation
     */
    public $destination;
    /**
     * The summary
     * @var \StructType\RouteSummary
     */
    public $summary;
    /**
     * The map
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $map;
    /**
     * Constructor method for RoutePlannerRoute
     * @uses RoutePlannerRoute::setDescription()
     * @uses RoutePlannerRoute::setStart()
     * @uses RoutePlannerRoute::setDestination()
     * @uses RoutePlannerRoute::setSummary()
     * @uses RoutePlannerRoute::setMap()
     * @param \ArrayType\RoutePartArray $description
     * @param \StructType\RouteLocation $start
     * @param \StructType\RouteLocation $destination
     * @param \StructType\RouteSummary $summary
     * @param string $map
     */
    public function __construct(\ArrayType\RoutePartArray $description = null, \StructType\RouteLocation $start = null, \StructType\RouteLocation $destination = null, \StructType\RouteSummary $summary = null, $map = null)
    {
        $this
            ->setDescription($description)
            ->setStart($start)
            ->setDestination($destination)
            ->setSummary($summary)
            ->setMap($map);
    }
    /**
     * Get description value
     * @return \ArrayType\RoutePartArray
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param \ArrayType\RoutePartArray $description
     * @return \StructType\RoutePlannerRoute
     */
    public function setDescription(\ArrayType\RoutePartArray $description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get start value
     * @return \StructType\RouteLocation|null
     */
    public function getStart()
    {
        return $this->start;
    }
    /**
     * Set start value
     * @param \StructType\RouteLocation $start
     * @return \StructType\RoutePlannerRoute
     */
    public function setStart(\StructType\RouteLocation $start = null)
    {
        $this->start = $start;
        return $this;
    }
    /**
     * Get destination value
     * @return \StructType\RouteLocation|null
     */
    public function getDestination()
    {
        return $this->destination;
    }
    /**
     * Set destination value
     * @param \StructType\RouteLocation $destination
     * @return \StructType\RoutePlannerRoute
     */
    public function setDestination(\StructType\RouteLocation $destination = null)
    {
        $this->destination = $destination;
        return $this;
    }
    /**
     * Get summary value
     * @return \StructType\RouteSummary|null
     */
    public function getSummary()
    {
        return $this->summary;
    }
    /**
     * Set summary value
     * @param \StructType\RouteSummary $summary
     * @return \StructType\RoutePlannerRoute
     */
    public function setSummary(\StructType\RouteSummary $summary = null)
    {
        $this->summary = $summary;
        return $this;
    }
    /**
     * Get map value
     * @return string|null
     */
    public function getMap()
    {
        return $this->map;
    }
    /**
     * Set map value
     * @param string $map
     * @return \StructType\RoutePlannerRoute
     */
    public function setMap($map = null)
    {
        // validation for constraint: string
        if (!is_null($map) && !is_string($map)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($map, true), gettype($map)), __LINE__);
        }
        $this->map = $map;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RoutePlannerRoute
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
